
SELECT 'create,insert,drop Test: Start Testing Multi/POINT'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/POINT'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/LINESTRING'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/LINESTRING'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/POLYGON'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/POLYGON'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/POINTM'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/POINTM'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/LINESTRINGM'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/LINESTRINGM'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/POLYGONM'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/POLYGONM'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/POINT'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/POINT'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/LINESTRING'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/LINESTRING'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/POLYGON'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/POLYGON'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/GEOMETRYCOLLECTION'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/GEOMETRYCOLLECTION'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/CURVEPOLYGON'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/CURVEPOLYGON'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/CIRCULARSTRING'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/CIRCULARSTRING'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/MULTIPOINT'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/MULTIPOINT'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/MULTILINESTRING'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/MULTILINESTRING'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/POLYGON'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/POLYGON'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/MULTIPOINT'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/MULTIPOINT'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/MULTILINESTRING'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/MULTILINESTRING'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/MULTIPOLYGON'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/MULTIPOLYGON'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/MULTIPOINTM'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/MULTIPOINTM'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/MULTILINESTRINGM'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/MULTILINESTRINGM'; 
	
	
	
SELECT 'create,insert,drop Test: Start Testing Multi/MULTIPOLYGONM'; 
BEGIN;
	CREATE TABLE pgis_garden (gid serial);
	SELECT AddGeometryColumn('pgis_garden','the_geom',ST_SRID(the_geom),GeometryType(the_geom),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo limit 1;
	SELECT AddGeometryColumn('pgis_garden','the_geom_multi',ST_SRID(the_geom),GeometryType(ST_Multi(the_geom)),ST_CoordDim(the_geom))
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo limit 1;
	INSERT INTO pgis_garden(the_geom, the_geom_multi)
	SELECT the_geom, ST_Multi(the_geom)
	FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo;
	
	SELECT UpdateGeometrySRID('pgis_garden', 'the_geom', 4269);
	
	SELECT DropGeometryColumn ('pgis_garden','the_geom');
	SELECT DropGeometryTable ('pgis_garden');
COMMIT;
SELECT 'create,insert,drop Test: Start Testing Multi/MULTIPOLYGONM'; 
	
	
	
		SELECT '|>> PointSet : Start Testing PointSet against other types'; 
						
			SELECT '|>> PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> PointSet: End Testing POINT against other types';
				
		SELECT '|>> LineSet : Start Testing LineSet against other types'; 
						
			SELECT '|>> PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> LineSet: End Testing LINESTRING against other types';
				
		SELECT '|>> PolySet : Start Testing PolySet against other types'; 
						
			SELECT '|>> PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> PolySet: End Testing POLYGON against other types';
				
		SELECT '|>> PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '|>> PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> PointMSet: End Testing POINTM against other types';
				
		SELECT '|>> LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '|>> PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '|>> PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '|>> PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '|>> PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '|>> PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> PointSet3D: End Testing POINT against other types';
				
		SELECT '|>> LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '|>> PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '|>> PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '|>> PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '|>> GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '|>> PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '|>> CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '|>> PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '|>> CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '|>> PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '|>> MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '|>> PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '|>> MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '|>> PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '|>> MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '|>> PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '|>> MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '|>> PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '|>> MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '|>> PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '|>> MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '|>> PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '|>> MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '|>> PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '|>> MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '|>> PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '|>> MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '|>> PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|>> MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |>> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|>> MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				
		SELECT '<<| PointSet : Start Testing PointSet against other types'; 
						
			SELECT '<<| PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| PointSet: End Testing POINT against other types';
				
		SELECT '<<| LineSet : Start Testing LineSet against other types'; 
						
			SELECT '<<| PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| LineSet: End Testing LINESTRING against other types';
				
		SELECT '<<| PolySet : Start Testing PolySet against other types'; 
						
			SELECT '<<| PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| PolySet: End Testing POLYGON against other types';
				
		SELECT '<<| PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '<<| PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| PointMSet: End Testing POINTM against other types';
				
		SELECT '<<| LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '<<| PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '<<| PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '<<| PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '<<| PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '<<| PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| PointSet3D: End Testing POINT against other types';
				
		SELECT '<<| LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '<<| PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '<<| PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '<<| PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '<<| GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '<<| PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '<<| CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '<<| PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '<<| CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '<<| PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '<<| MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '<<| PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '<<| MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '<<| PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '<<| MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '<<| PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '<<| MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '<<| PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '<<| MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '<<| PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '<<| MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '<<| PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '<<| MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '<<| PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '<<| MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '<<| PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '<<| MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '<<| PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<<| MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom <<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<<| MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				
		SELECT '~ PointSet : Start Testing PointSet against other types'; 
						
			SELECT '~ PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ PointSet: End Testing POINT against other types';
				
		SELECT '~ LineSet : Start Testing LineSet against other types'; 
						
			SELECT '~ PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ LineSet: End Testing LINESTRING against other types';
				
		SELECT '~ PolySet : Start Testing PolySet against other types'; 
						
			SELECT '~ PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ PolySet: End Testing POLYGON against other types';
				
		SELECT '~ PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '~ PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ PointMSet: End Testing POINTM against other types';
				
		SELECT '~ LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '~ PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '~ PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '~ PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '~ PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '~ PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ PointSet3D: End Testing POINT against other types';
				
		SELECT '~ LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '~ PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '~ PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '~ PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '~ GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '~ PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '~ CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '~ PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '~ CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '~ PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '~ MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '~ PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '~ MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '~ PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '~ MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '~ PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '~ MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '~ PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '~ MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '~ PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '~ MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '~ PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '~ MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '~ PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '~ MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '~ PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '~ MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '~ PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~ MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~ foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~ MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				
		SELECT '~= PointSet : Start Testing PointSet against other types'; 
						
			SELECT '~= PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= PointSet: End Testing POINT against other types';
				
		SELECT '~= LineSet : Start Testing LineSet against other types'; 
						
			SELECT '~= PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= LineSet: End Testing LINESTRING against other types';
				
		SELECT '~= PolySet : Start Testing PolySet against other types'; 
						
			SELECT '~= PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= PolySet: End Testing POLYGON against other types';
				
		SELECT '~= PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '~= PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= PointMSet: End Testing POINTM against other types';
				
		SELECT '~= LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '~= PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '~= PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '~= PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '~= PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= PointSet3D: End Testing POINT against other types';
				
		SELECT '~= LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '~= PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '~= GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '~= CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '~= PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '~= CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '~= PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '~= MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '~= MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '~= MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '~= MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '~= MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '~= MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '~= MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '~= MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '~= MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				
		SELECT '= PointSet : Start Testing PointSet against other types'; 
						
			SELECT '= PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= PointSet: End Testing POINT against other types';
				
		SELECT '= LineSet : Start Testing LineSet against other types'; 
						
			SELECT '= PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= LineSet: End Testing LINESTRING against other types';
				
		SELECT '= PolySet : Start Testing PolySet against other types'; 
						
			SELECT '= PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= PolySet: End Testing POLYGON against other types';
				
		SELECT '= PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '= PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= PointMSet: End Testing POINTM against other types';
				
		SELECT '= LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '= PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '= PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '= PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '= PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '= PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= PointSet3D: End Testing POINT against other types';
				
		SELECT '= LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '= PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '= PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '= PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '= GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '= PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '= CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '= PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '= CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '= PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '= MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '= PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '= MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '= PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '= MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '= PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '= MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '= PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '= MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '= PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '= MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '= PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '= MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '= PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '= MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '= PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '= MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '= PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '= MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom = foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '= MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				
		SELECT '<< PointSet : Start Testing PointSet against other types'; 
						
			SELECT '<< PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< PointSet: End Testing POINT against other types';
				
		SELECT '<< LineSet : Start Testing LineSet against other types'; 
						
			SELECT '<< PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< LineSet: End Testing LINESTRING against other types';
				
		SELECT '<< PolySet : Start Testing PolySet against other types'; 
						
			SELECT '<< PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< PolySet: End Testing POLYGON against other types';
				
		SELECT '<< PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '<< PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< PointMSet: End Testing POINTM against other types';
				
		SELECT '<< LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '<< PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '<< PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '<< PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '<< PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '<< PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< PointSet3D: End Testing POINT against other types';
				
		SELECT '<< LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '<< PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '<< PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '<< PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '<< GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '<< PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '<< CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '<< PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '<< CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '<< PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '<< MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '<< PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '<< MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '<< PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '<< MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '<< PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '<< MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '<< PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '<< MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '<< PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '<< MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '<< PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '<< MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '<< PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '<< MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '<< PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '<< MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '<< PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '<< MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom << foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '<< MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				
		SELECT '|&> PointSet : Start Testing PointSet against other types'; 
						
			SELECT '|&> PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> PointSet: End Testing POINT against other types';
				
		SELECT '|&> LineSet : Start Testing LineSet against other types'; 
						
			SELECT '|&> PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> LineSet: End Testing LINESTRING against other types';
				
		SELECT '|&> PolySet : Start Testing PolySet against other types'; 
						
			SELECT '|&> PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> PolySet: End Testing POLYGON against other types';
				
		SELECT '|&> PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '|&> PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> PointMSet: End Testing POINTM against other types';
				
		SELECT '|&> LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '|&> PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '|&> PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '|&> PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '|&> PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '|&> PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> PointSet3D: End Testing POINT against other types';
				
		SELECT '|&> LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '|&> PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '|&> PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '|&> PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '|&> GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '|&> PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '|&> CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '|&> PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '|&> CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '|&> PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '|&> MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '|&> PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '|&> MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '|&> PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '|&> MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '|&> PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '|&> MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '|&> PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '|&> MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '|&> PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '|&> MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '|&> PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '|&> MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '|&> PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '|&> MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '|&> PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '|&> MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '|&> PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '|&> MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom |&> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '|&> MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				
		SELECT '&<| PointSet : Start Testing PointSet against other types'; 
						
			SELECT '&<| PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| PointSet: End Testing POINT against other types';
				
		SELECT '&<| LineSet : Start Testing LineSet against other types'; 
						
			SELECT '&<| PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| LineSet: End Testing LINESTRING against other types';
				
		SELECT '&<| PolySet : Start Testing PolySet against other types'; 
						
			SELECT '&<| PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| PolySet: End Testing POLYGON against other types';
				
		SELECT '&<| PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '&<| PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| PointMSet: End Testing POINTM against other types';
				
		SELECT '&<| LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '&<| PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '&<| PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '&<| PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '&<| PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '&<| PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| PointSet3D: End Testing POINT against other types';
				
		SELECT '&<| LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '&<| PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '&<| PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '&<| PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '&<| GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '&<| PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '&<| CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '&<| PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '&<| CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '&<| PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '&<| MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '&<| PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '&<| MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '&<| PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '&<| MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '&<| PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '&<| MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '&<| PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '&<| MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '&<| PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '&<| MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '&<| PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '&<| MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '&<| PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '&<| MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '&<| PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '&<| MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '&<| PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&<| MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &<| foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&<| MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				
		SELECT '&& PointSet : Start Testing PointSet against other types'; 
						
			SELECT '&& PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& PointSet: End Testing POINT against other types';
				
		SELECT '&& LineSet : Start Testing LineSet against other types'; 
						
			SELECT '&& PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& LineSet: End Testing LINESTRING against other types';
				
		SELECT '&& PolySet : Start Testing PolySet against other types'; 
						
			SELECT '&& PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& PolySet: End Testing POLYGON against other types';
				
		SELECT '&& PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '&& PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& PointMSet: End Testing POINTM against other types';
				
		SELECT '&& LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '&& PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '&& PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '&& PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '&& PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '&& PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& PointSet3D: End Testing POINT against other types';
				
		SELECT '&& LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '&& PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '&& PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '&& PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '&& GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '&& PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '&& CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '&& PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '&& CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '&& PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '&& MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '&& PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '&& MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '&& PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '&& MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '&& PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '&& MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '&& PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '&& MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '&& PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '&& MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '&& PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '&& MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '&& PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '&& MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '&& PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '&& MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '&& PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&& MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom && foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&& MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				
		SELECT '&< PointSet : Start Testing PointSet against other types'; 
						
			SELECT '&< PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< PointSet: End Testing POINT against other types';
				
		SELECT '&< LineSet : Start Testing LineSet against other types'; 
						
			SELECT '&< PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< LineSet: End Testing LINESTRING against other types';
				
		SELECT '&< PolySet : Start Testing PolySet against other types'; 
						
			SELECT '&< PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< PolySet: End Testing POLYGON against other types';
				
		SELECT '&< PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '&< PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< PointMSet: End Testing POINTM against other types';
				
		SELECT '&< LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '&< PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '&< PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '&< PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '&< PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '&< PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< PointSet3D: End Testing POINT against other types';
				
		SELECT '&< LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '&< PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '&< PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '&< PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '&< GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '&< PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '&< CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '&< PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '&< CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '&< PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '&< MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '&< PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '&< MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '&< PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '&< MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '&< PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '&< MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '&< PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '&< MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '&< PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '&< MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '&< PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '&< MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '&< PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '&< MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '&< PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '&< MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '&< PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&< MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &< foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&< MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				
		SELECT '&> PointSet : Start Testing PointSet against other types'; 
						
			SELECT '&> PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> PointSet: End Testing POINT against other types';
				
		SELECT '&> LineSet : Start Testing LineSet against other types'; 
						
			SELECT '&> PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> LineSet: End Testing LINESTRING against other types';
				
		SELECT '&> PolySet : Start Testing PolySet against other types'; 
						
			SELECT '&> PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> PolySet: End Testing POLYGON against other types';
				
		SELECT '&> PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '&> PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> PointMSet: End Testing POINTM against other types';
				
		SELECT '&> LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '&> PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '&> PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '&> PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '&> PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '&> PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> PointSet3D: End Testing POINT against other types';
				
		SELECT '&> LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '&> PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '&> PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '&> PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '&> GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '&> PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '&> CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '&> PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '&> CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '&> PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '&> MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '&> PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '&> MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '&> PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '&> MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '&> PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '&> MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '&> PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '&> MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '&> PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '&> MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '&> PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '&> MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '&> PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '&> MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '&> PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '&> MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '&> PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '&> MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom &> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '&> MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				
		SELECT '>> PointSet : Start Testing PointSet against other types'; 
						
			SELECT '>> PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> PointSet: End Testing POINT against other types';
				
		SELECT '>> LineSet : Start Testing LineSet against other types'; 
						
			SELECT '>> PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> LineSet: End Testing LINESTRING against other types';
				
		SELECT '>> PolySet : Start Testing PolySet against other types'; 
						
			SELECT '>> PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> PolySet: End Testing POLYGON against other types';
				
		SELECT '>> PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '>> PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> PointMSet: End Testing POINTM against other types';
				
		SELECT '>> LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '>> PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '>> PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '>> PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '>> PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '>> PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> PointSet3D: End Testing POINT against other types';
				
		SELECT '>> LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '>> PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '>> PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '>> PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '>> GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '>> PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '>> CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '>> PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '>> CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '>> PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '>> MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '>> PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '>> MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '>> PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '>> MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '>> PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '>> MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '>> PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '>> MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '>> PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '>> MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '>> PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '>> MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '>> PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '>> MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '>> PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '>> MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '>> PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '>> MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom >> foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '>> MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				
		SELECT '~= PointSet : Start Testing PointSet against other types'; 
						
			SELECT '~= PointSet: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing PointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing PointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing PointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing PointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing PointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing PointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing PointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing PointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing PointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing PointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing PointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing PointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing PointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing PointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing PointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= PointSet: End Testing POINT against other types';
				
		SELECT '~= LineSet : Start Testing LineSet against other types'; 
						
			SELECT '~= PointSet: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing LineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing LineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing LineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing LineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing LineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing LineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing LineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing LineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing LineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing LineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing LineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing LineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing LineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing LineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing LineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= LineSet: End Testing LINESTRING against other types';
				
		SELECT '~= PolySet : Start Testing PolySet against other types'; 
						
			SELECT '~= PointSet: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing PolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing PolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing PolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing PolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing PolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing PolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing PolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing PolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing PolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing PolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing PolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing PolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing PolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing PolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing PolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= PolySet: End Testing POLYGON against other types';
				
		SELECT '~= PointMSet : Start Testing PointMSet against other types'; 
						
			SELECT '~= PointSet: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing PointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing PointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing PointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing PointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing PointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing PointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing PointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing PointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing PointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing PointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing PointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing PointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing PointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing PointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing PointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= PointMSet: End Testing POINTM against other types';
				
		SELECT '~= LineMSet : Start Testing LineMSet against other types'; 
						
			SELECT '~= PointSet: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing LineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing LineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing LineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing LineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing LineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing LineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing LineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing LineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing LineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing LineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing LineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing LineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing LineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing LineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing LineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= LineMSet: End Testing LINESTRINGM against other types';
				
		SELECT '~= PolygonMSet : Start Testing PolygonMSet against other types'; 
						
			SELECT '~= PointSet: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing PolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing PolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing PolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing PolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing PolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing PolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing PolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing PolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing PolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing PolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing PolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing PolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing PolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing PolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= PolygonMSet: End Testing POLYGONM against other types';
				
		SELECT '~= PointSet3D : Start Testing PointSet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing PointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing PointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing PointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing PointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing PointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing PointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing PointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing PointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing PointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing PointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing PointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing PointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing PointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing PointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= PointSet3D: End Testing POINT against other types';
				
		SELECT '~= LineSet3D : Start Testing LineSet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing LineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing LineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing LineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing LineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing LineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing LineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing LineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing LineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing LineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing LineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing LineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing LineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing LineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing LineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= LineSet3D: End Testing LINESTRING against other types';
				
		SELECT '~= PolygonSet3D : Start Testing PolygonSet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing PolygonSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing PolygonSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing PolygonSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing PolygonSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing PolygonSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing PolygonSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing PolygonSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing PolygonSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing PolygonSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing PolygonSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing PolygonSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing PolygonSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing PolygonSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing PolygonSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= PolygonSet3D: End Testing POLYGON against other types';
				
		SELECT '~= GCSet3D : Start Testing GCSet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing GCSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing GCSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing GCSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing GCSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing GCSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing GCSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing GCSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing GCSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing GCSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing GCSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing GCSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing GCSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing GCSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing GCSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= GCSet3D: End Testing GEOMETRYCOLLECTION against other types';
				
		SELECT '~= CurvePolySet : Start Testing CurvePolySet against other types'; 
						
			SELECT '~= PointSet: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing CurvePolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing CurvePolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing CurvePolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing CurvePolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing CurvePolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing CurvePolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing CurvePolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing CurvePolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing CurvePolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing CurvePolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing CurvePolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing CurvePolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing CurvePolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing CurvePolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= CurvePolySet: End Testing CURVEPOLYGON against other types';
				
		SELECT '~= CircularStringSet : Start Testing CircularStringSet against other types'; 
						
			SELECT '~= PointSet: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing CircularStringSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing CircularStringSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing CircularStringSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing CircularStringSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing CircularStringSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing CircularStringSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing CircularStringSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing CircularStringSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing CircularStringSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing CircularStringSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing CircularStringSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing CircularStringSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing CircularStringSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing CircularStringSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= CircularStringSet: End Testing CIRCULARSTRING against other types';
				
		SELECT '~= MultiPointSet : Start Testing MultiPointSet against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiPointSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiPointSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiPointSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiPointSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiPointSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiPointSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiPointSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiPointSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiPointSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiPointSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiPointSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiPointSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiPointSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiPointSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiPointSet: End Testing MULTIPOINT against other types';
				
		SELECT '~= MultiLineSet : Start Testing MultiLineSet against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiLineSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiLineSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiLineSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiLineSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiLineSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiLineSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiLineSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiLineSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiLineSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiLineSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiLineSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiLineSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiLineSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiLineSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiLineSet: End Testing MULTILINESTRING against other types';
				
		SELECT '~= MultiPolySet : Start Testing MultiPolySet against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiPolySet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiPolySet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiPolySet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiPolySet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiPolySet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiPolySet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiPolySet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiPolySet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiPolySet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiPolySet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiPolySet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiPolySet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiPolySet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiPolySet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiPolySet: End Testing POLYGON against other types';
				
		SELECT '~= MultiPointSet3D : Start Testing MultiPointSet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiPointSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiPointSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiPointSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiPointSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiPointSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiPointSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiPointSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiPointSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiPointSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiPointSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiPointSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiPointSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiPointSet3D: End Testing MULTIPOINT against other types';
				
		SELECT '~= MultiLineSet3D : Start Testing MultiLineSet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiLineSet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiLineSet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiLineSet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiLineSet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiLineSet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiLineSet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiLineSet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiLineSet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiLineSet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiLineSet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiLineSet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiLineSet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiLineSet3D: End Testing MULTILINESTRING against other types';
				
		SELECT '~= MultiPolySet3D : Start Testing MultiPolySet3D against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiPolySet3D, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiPolySet3D, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiPolySet3D, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiPolySet3D, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiPolySet3D, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiPolySet3D, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiPolySet3D, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiPolySet3D, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiPolySet3D, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiPolySet3D, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiPolySet3D, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiPolySet3D, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiPolySet3D: End Testing MULTIPOLYGON against other types';
				
		SELECT '~= MultiPointMSet : Start Testing MultiPointMSet against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiPointMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiPointMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiPointMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiPointMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiPointMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiPointMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiPointMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiPointMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiPointMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiPointMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiPointMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiPointMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiPointMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiPointMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiPointMSet: End Testing MULTIPOINTM against other types';
				
		SELECT '~= MultiLineMSet : Start Testing MultiLineMSet against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiLineMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiLineMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiLineMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiLineMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiLineMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiLineMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiLineMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiLineMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiLineMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiLineMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiLineMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiLineMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiLineMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiLineMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiLineMSet: End Testing MULTILINESTRINGM against other types';
				
		SELECT '~= MultiPolygonMSet : Start Testing MultiPolygonMSet against other types'; 
						
			SELECT '~= PointSet: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointMSet: Start Testing MultiPolygonMSet, POINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineMSet: Start Testing MultiPolygonMSet, LINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonMSet: Start Testing MultiPolygonMSet, POLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PointSet3D: Start Testing MultiPolygonMSet, POINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= LineSet3D: Start Testing MultiPolygonMSet, LINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= PolygonSet3D: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= GCSet3D: Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CurvePolySet: Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= CircularStringSet: Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet: Start Testing MultiPolygonMSet, POLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointSet3D: Start Testing MultiPolygonMSet, MULTIPOINT'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineSet3D: Start Testing MultiPolygonMSet, MULTILINESTRING'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolySet3D: Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPointMSet: Start Testing MultiPolygonMSet, MULTIPOINTM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiLineMSet: Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
					LIMIT 3;  
			COMMIT;
					
			SELECT '~= MultiPolygonMSet: Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
			BEGIN; 
			SELECT foo1.the_geom ~= foo2.the_geom
					FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
					LIMIT 3;  
			COMMIT;
					
		SELECT '~= MultiPolygonMSet: End Testing MULTIPOLYGONM against other types';
				SELECT  'Starting AddAuth(auth_token)';BEGIN; 
SELECT  AddAuth('monkey');
COMMIT;
SELECT  'Ending AddAuth(auth_token)';
	SELECT  'Starting CheckAuth(a_schema_name, a_table_name, a_key_column_name)';BEGIN; 
SELECT  CheckAuth('monkey', 'monkey', 'monkey');
COMMIT;
SELECT  'Ending CheckAuth(a_schema_name, a_table_name, a_key_column_name)';
	SELECT  'Starting CheckAuth(a_table_name, a_key_column_name)';BEGIN; 
SELECT  CheckAuth('monkey', 'monkey');
COMMIT;
SELECT  'Ending CheckAuth(a_table_name, a_key_column_name)';
	SELECT  'Starting DisableLongTransactions()';BEGIN; 
SELECT  DisableLongTransactions();
COMMIT;
SELECT  'Ending DisableLongTransactions()';
	SELECT  'Starting EnableLongTransactions()';BEGIN; 
SELECT  EnableLongTransactions();
COMMIT;
SELECT  'Ending EnableLongTransactions()';
	SELECT  'Starting Find_SRID(a_schema_name, a_table_name, a_geomfield_name)';BEGIN; 
SELECT  Find_SRID('test', 'test', 'test');
COMMIT;
SELECT  'Ending Find_SRID(a_schema_name, a_table_name, a_geomfield_name)';
	
	SELECT 'GeometryType PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'GeometryType PointSet: End Testing POINT';
		
		
		
	SELECT 'GeometryType LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'GeometryType LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'GeometryType PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'GeometryType PolySet: End Testing POLYGON';
		
		
		
	SELECT 'GeometryType PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'GeometryType PointMSet: End Testing POINTM';
		
		
		
	SELECT 'GeometryType LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'GeometryType LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'GeometryType PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'GeometryType PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'GeometryType PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'GeometryType PointSet3D: End Testing POINT';
		
		
		
	SELECT 'GeometryType LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'GeometryType LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'GeometryType PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'GeometryType PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'GeometryType GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'GeometryType GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'GeometryType CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'GeometryType CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'GeometryType CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'GeometryType CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'GeometryType MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'GeometryType MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'GeometryType MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'GeometryType MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'GeometryType MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'GeometryType MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'GeometryType MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'GeometryType MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'GeometryType MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'GeometryType MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'GeometryType MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'GeometryType MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'GeometryType MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'GeometryType MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'GeometryType MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'GeometryType MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'GeometryType MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'GeometryType MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		SELECT  'Starting LockRow(a_schema_name, a_table_name, a_row_key, an_auth_token, expire_dt)';BEGIN; 
SELECT  LockRow('monkey', 'monkey', 'monkey', 'monkey', '2009-01-01');
COMMIT;
SELECT  'Ending LockRow(a_schema_name, a_table_name, a_row_key, an_auth_token, expire_dt)';
	SELECT  'Starting LockRow(a_table_name, a_row_key, an_auth_token, expire_dt)';BEGIN; 
SELECT  LockRow('monkey', 'monkey', 'monkey', '2009-01-01');
COMMIT;
SELECT  'Ending LockRow(a_table_name, a_row_key, an_auth_token, expire_dt)';
	SELECT  'Starting LockRow(a_table_name, a_row_key, an_auth_token)';BEGIN; 
SELECT  LockRow('monkey', 'monkey', 'monkey');
COMMIT;
SELECT  'Ending LockRow(a_table_name, a_row_key, an_auth_token)';
	SELECT  'Starting Populate_Geometry_Columns()';BEGIN; 
SELECT  Populate_Geometry_Columns();
COMMIT;
SELECT  'Ending Populate_Geometry_Columns()';
	SELECT  'Starting Populate_Geometry_Columns(table_oid)';BEGIN; 
SELECT  Populate_Geometry_Columns();
COMMIT;
SELECT  'Ending Populate_Geometry_Columns(table_oid)';
	SELECT  'Starting PostGIS_Full_Version()';BEGIN; 
SELECT  PostGIS_Full_Version();
COMMIT;
SELECT  'Ending PostGIS_Full_Version()';
	SELECT  'Starting PostGIS_GEOS_Version()';BEGIN; 
SELECT  PostGIS_GEOS_Version();
COMMIT;
SELECT  'Ending PostGIS_GEOS_Version()';
	SELECT  'Starting PostGIS_Lib_Build_Date()';BEGIN; 
SELECT  PostGIS_Lib_Build_Date();
COMMIT;
SELECT  'Ending PostGIS_Lib_Build_Date()';
	SELECT  'Starting PostGIS_Lib_Version()';BEGIN; 
SELECT  PostGIS_Lib_Version();
COMMIT;
SELECT  'Ending PostGIS_Lib_Version()';
	SELECT  'Starting PostGIS_PROJ_Version()';BEGIN; 
SELECT  PostGIS_PROJ_Version();
COMMIT;
SELECT  'Ending PostGIS_PROJ_Version()';
	SELECT  'Starting PostGIS_Scripts_Build_Date()';BEGIN; 
SELECT  PostGIS_Scripts_Build_Date();
COMMIT;
SELECT  'Ending PostGIS_Scripts_Build_Date()';
	SELECT  'Starting PostGIS_Scripts_Installed()';BEGIN; 
SELECT  PostGIS_Scripts_Installed();
COMMIT;
SELECT  'Ending PostGIS_Scripts_Installed()';
	SELECT  'Starting PostGIS_Scripts_Released()';BEGIN; 
SELECT  PostGIS_Scripts_Released();
COMMIT;
SELECT  'Ending PostGIS_Scripts_Released()';
	SELECT  'Starting PostGIS_Uses_Stats()';BEGIN; 
SELECT  PostGIS_Uses_Stats();
COMMIT;
SELECT  'Ending PostGIS_Uses_Stats()';
	SELECT  'Starting PostGIS_Version()';BEGIN; 
SELECT  PostGIS_Version();
COMMIT;
SELECT  'Ending PostGIS_Version()';
	SELECT  'Starting Probe_Geometry_Columns()';BEGIN; 
SELECT  Probe_Geometry_Columns();
COMMIT;
SELECT  'Ending Probe_Geometry_Columns()';
	
	SELECT 'ST_Accum PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Accum LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Accum LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Accum PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Accum PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Accum LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Accum LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Accum PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Accum PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Accum LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Accum PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Accum GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Accum CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Accum CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Accum MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Accum MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Accum MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Accum MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Accum MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Accum MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Accum MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Accum MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Accum MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Accum(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Accum MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AddBBox PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AddBBox LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AddBBox PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AddBBox PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AddBBox LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AddBBox PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AddBBox PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AddBBox LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AddBBox PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AddBBox GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddBBox CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddBBox CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddBBox MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AddBBox MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AddBBox MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AddBBox MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AddBBox MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AddBBox MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddBBox MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AddBBox MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddBBox MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AddBBox MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing PointSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PointSet(linestring, point): End Testing POINT against other types';
		
SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing LineSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint LineSet(linestring, point): End Testing LINESTRING against other types';
		
SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing PolySet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PolySet(linestring, point): End Testing POLYGON against other types';
		
SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PointMSet(linestring, point): End Testing POINTM against other types';
		
SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint LineMSet(linestring, point): End Testing LINESTRINGM against other types';
		
SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PolygonMSet(linestring, point): End Testing POLYGONM against other types';
		
SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PointSet3D(linestring, point): End Testing POINT against other types';
		
SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint LineSet3D(linestring, point): End Testing LINESTRING against other types';
		
SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PolygonSet3D(linestring, point): End Testing POLYGON against other types';
		
SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint GCSet3D(linestring, point): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint CurvePolySet(linestring, point): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint CircularStringSet(linestring, point): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiPointSet(linestring, point): End Testing MULTIPOINT against other types';
		
SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiLineSet(linestring, point): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiPolySet(linestring, point): End Testing POLYGON against other types';
		
SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): End Testing MULTIPOINT against other types';
		
SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiPointMSet(linestring, point): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiLineMSet(linestring, point): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing PointSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PointSet(linestring, point, position): End Testing POINT against other types';
		
SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing LineSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint LineSet(linestring, point, position): End Testing LINESTRING against other types';
		
SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing PolySet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PolySet(linestring, point, position): End Testing POLYGON against other types';
		
SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PointMSet(linestring, point, position): End Testing POINTM against other types';
		
SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint LineMSet(linestring, point, position): End Testing LINESTRINGM against other types';
		
SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): End Testing POLYGONM against other types';
		
SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PointSet3D(linestring, point, position): End Testing POINT against other types';
		
SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint LineSet3D(linestring, point, position): End Testing LINESTRING against other types';
		
SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): End Testing POLYGON against other types';
		
SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint GCSet3D(linestring, point, position): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): End Testing MULTIPOINT against other types';
		
SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): End Testing POLYGON against other types';
		
SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): End Testing MULTIPOINT against other types';
		
SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_AddPoint PointSet(linestring, point, position): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet(linestring, point, position): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolySet(linestring, point, position): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint PointMSet(linestring, point, position): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_AddPoint LineMSet(linestring, point, position): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint PolygonMSet(linestring, point, position): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_AddPoint PointSet3D(linestring, point, position): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_AddPoint LineSet3D(linestring, point, position): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_AddPoint PolygonSet3D(linestring, point, position): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint GCSet3D(linestring, point, position): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AddPoint CurvePolySet(linestring, point, position): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_AddPoint CircularStringSet(linestring, point, position): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet(linestring, point, position): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet(linestring, point, position): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet(linestring, point, position): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointSet3D(linestring, point, position): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_AddPoint MultiLineSet3D(linestring, point, position): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_AddPoint MultiPolySet3D(linestring, point, position): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_AddPoint MultiPointMSet(linestring, point, position): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_AddPoint MultiLineMSet(linestring, point, position): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_AddPoint(foo1.the_geom, foo2.the_geom, 1))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_AddPoint(linestring, point, position)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_AddPoint MultiPolygonMSet(linestring, point, position): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_Affine PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Affine LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Affine LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Affine PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Affine PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Affine LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Affine LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Affine PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Affine PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Affine LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Affine PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Affine GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Affine CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Affine CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Affine MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Affine MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Affine MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Affine MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Affine MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Affine MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Affine MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Affine MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Affine MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Affine PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Affine LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Affine LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Affine PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Affine PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Affine LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Affine LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Affine PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Affine PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Affine LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Affine PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Affine GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Affine CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Affine CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Affine MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Affine MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Affine MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Affine MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Affine MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Affine MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Affine MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Affine MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Affine MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Affine(foo1.the_geom, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Affine MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Area PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Area PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Area LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Area LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Area PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Area PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Area PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Area PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Area LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Area LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Area PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Area PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Area PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Area PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Area LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Area LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Area PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Area PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Area GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Area GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Area CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Area CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Area CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Area CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Area MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Area MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Area MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Area MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Area MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Area MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Area MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Area MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Area MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Area MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Area MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Area MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Area MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Area MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Area MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Area MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Area MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Area(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Area MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsBinary PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsBinary LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsBinary PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsBinary PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsBinary LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsBinary PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsBinary PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsBinary LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsBinary PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsBinary GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsBinary CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsBinary CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsBinary MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsBinary MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsBinary MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsBinary MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsBinary MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsBinary MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsBinary MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsBinary MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsBinary MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsBinary PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsBinary LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsBinary PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsBinary PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsBinary LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsBinary PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsBinary PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsBinary LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsBinary PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsBinary GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsBinary CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsBinary CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsBinary MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsBinary MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsBinary MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsBinary MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsBinary MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsBinary MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsBinary MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsBinary MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsBinary MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsBinary(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsBinary MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsEWKB PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsEWKB LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsEWKB PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsEWKB PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsEWKB LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsEWKB PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsEWKB PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsEWKB LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsEWKB PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsEWKB GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsEWKB CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsEWKB CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsEWKB MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsEWKB MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsEWKB MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsEWKB MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsEWKB MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsEWKB MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsEWKB MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsEWKB MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsEWKB MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsEWKB PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsEWKB LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsEWKB PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsEWKB PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsEWKB LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsEWKB PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsEWKB PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsEWKB LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsEWKB PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsEWKB GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsEWKB CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsEWKB CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsEWKB MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsEWKB MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsEWKB MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsEWKB MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsEWKB MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsEWKB MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsEWKB MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsEWKB MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsEWKB MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKB MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsEWKT PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsEWKT LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsEWKT PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsEWKT PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsEWKT LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsEWKT PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsEWKT PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsEWKT LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsEWKT PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsEWKT GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsEWKT CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsEWKT CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsEWKT MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsEWKT MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsEWKT MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsEWKT MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsEWKT MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsEWKT MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsEWKT MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsEWKT MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsEWKT MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsEWKT MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsGML PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsGML LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGML PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGML PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsGML LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsGML PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsGML PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsGML LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGML PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGML GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsGML CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsGML CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsGML MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGML MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGML MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGML MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGML MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGML MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsGML MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsGML MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsGML MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsGML PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsGML LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGML PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGML PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsGML LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsGML PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsGML PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsGML LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGML PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGML GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsGML CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsGML CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsGML MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGML MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGML MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGML MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGML MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGML MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsGML MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsGML MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsGML MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsGML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsGML PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsGML LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGML PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGML PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsGML LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsGML PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsGML PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsGML LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGML PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGML GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsGML CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsGML CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsGML MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGML MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGML MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGML MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGML MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGML MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsGML MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsGML MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsGML MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsGML PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsGML LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGML PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGML PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsGML LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsGML PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsGML PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsGML LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGML PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGML GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsGML CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsGML CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsGML MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGML MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGML MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGML MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGML MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGML MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsGML MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsGML MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsGML MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsGML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGML MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsGeoJSON PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsGeoJSON LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsGeoJSON LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsGeoJSON PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsGeoJSON PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsGeoJSON LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsGeoJSON CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsGeoJSON PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsGeoJSON LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsGeoJSON LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsGeoJSON PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsGeoJSON PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsGeoJSON LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsGeoJSON CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsGeoJSON PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsGeoJSON LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsGeoJSON LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsGeoJSON PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsGeoJSON PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsGeoJSON LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsGeoJSON CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsGeoJSON PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsGeoJSON LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsGeoJSON LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsGeoJSON PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsGeoJSON PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsGeoJSON LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsGeoJSON CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsGeoJSON PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsGeoJSON LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsGeoJSON LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsGeoJSON PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsGeoJSON PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsGeoJSON LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsGeoJSON CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsGeoJSON PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsGeoJSON LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsGeoJSON LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsGeoJSON PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsGeoJSON PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsGeoJSON LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsGeoJSON CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsGeoJSON MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsGeoJSON MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsGeoJSON(2, foo1.the_geom, 5, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsGeoJSON MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsHEXEWKB PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsHEXEWKB LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsHEXEWKB PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsHEXEWKB PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsHEXEWKB LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsHEXEWKB PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsHEXEWKB PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsHEXEWKB LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsHEXEWKB PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsHEXEWKB GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsHEXEWKB CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsHEXEWKB CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom,  
						'XDR'
					)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsHEXEWKB PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsHEXEWKB LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsHEXEWKB PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsHEXEWKB PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsHEXEWKB LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsHEXEWKB PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsHEXEWKB PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsHEXEWKB LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsHEXEWKB PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsHEXEWKB GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsHEXEWKB CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsHEXEWKB CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsHEXEWKB MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsHEXEWKB(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsHEXEWKB MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsKML PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsKML LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsKML PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsKML PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsKML LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsKML PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsKML PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsKML LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsKML PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsKML GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsKML CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsKML CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsKML MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsKML MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsKML MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsKML MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsKML MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsKML MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsKML MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsKML MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsKML MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsKML PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsKML LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsKML PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsKML PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsKML LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsKML PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsKML PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsKML LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsKML PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsKML GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsKML CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsKML CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsKML MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsKML MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsKML MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsKML MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsKML MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsKML MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsKML MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsKML MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsKML MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsKML(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsKML PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsKML LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsKML PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsKML PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsKML LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsKML PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsKML PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsKML LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsKML PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsKML GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsKML CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsKML CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsKML MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsKML MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsKML MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsKML MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsKML MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsKML MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsKML MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsKML MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsKML MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsKML PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsKML LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsKML PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsKML PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsKML LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsKML PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsKML PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsKML LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsKML PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsKML GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsKML CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsKML CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsKML MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsKML MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsKML MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsKML MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsKML MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsKML MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsKML MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsKML MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsKML MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsKML(2, foo1.the_geom, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsKML MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsSVG PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsSVG LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsSVG PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsSVG PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsSVG LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsSVG PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsSVG PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsSVG LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsSVG PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsSVG GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsSVG CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsSVG CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsSVG MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsSVG MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsSVG MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsSVG MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsSVG MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsSVG MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsSVG MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsSVG MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsSVG MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsSVG PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsSVG LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsSVG PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsSVG PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsSVG LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsSVG PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsSVG PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsSVG LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsSVG PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsSVG GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsSVG CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsSVG CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsSVG MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsSVG MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsSVG MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsSVG MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsSVG MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsSVG MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsSVG MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsSVG MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsSVG MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsSVG PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsSVG LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsSVG PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsSVG PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsSVG LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsSVG PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsSVG PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsSVG LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsSVG PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsSVG GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsSVG CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsSVG CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsSVG MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsSVG MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsSVG MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsSVG MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsSVG MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsSVG MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsSVG MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsSVG MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsSVG MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsSVG(foo1.the_geom, 3, 5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsSVG MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_AsText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_AsText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_AsText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_AsText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_AsText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_AsText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_AsText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_AsText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_AsText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_AsText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_AsText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_AsText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_AsText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_AsText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_AsText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_AsText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_AsText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsText(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_AsText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth PointSet(pointA, pointB): End Testing POINT against other types';
		
SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth LineSet(pointA, pointB): End Testing LINESTRING against other types';
		
SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth PolySet(pointA, pointB): End Testing POLYGON against other types';
		
SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth PointMSet(pointA, pointB): End Testing POINTM against other types';
		
SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth LineMSet(pointA, pointB): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): End Testing POLYGONM against other types';
		
SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth PointSet3D(pointA, pointB): End Testing POINT against other types';
		
SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth LineSet3D(pointA, pointB): End Testing LINESTRING against other types';
		
SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): End Testing POLYGON against other types';
		
SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth GCSet3D(pointA, pointB): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): End Testing POLYGON against other types';
		
SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Azimuth PointSet(pointA, pointB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet(pointA, pointB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolySet(pointA, pointB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth PointMSet(pointA, pointB): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Azimuth LineMSet(pointA, pointB): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth PolygonMSet(pointA, pointB): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Azimuth PointSet3D(pointA, pointB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Azimuth LineSet3D(pointA, pointB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Azimuth PolygonSet3D(pointA, pointB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth GCSet3D(pointA, pointB): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Azimuth CurvePolySet(pointA, pointB): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Azimuth CircularStringSet(pointA, pointB): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet(pointA, pointB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet(pointA, pointB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet(pointA, pointB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointSet3D(pointA, pointB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Azimuth MultiLineSet3D(pointA, pointB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Azimuth MultiPolySet3D(pointA, pointB): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Azimuth MultiPointMSet(pointA, pointB): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Azimuth MultiLineMSet(pointA, pointB): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Azimuth(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Azimuth(pointA, pointB)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Azimuth MultiPolygonMSet(pointA, pointB): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_BdMPolyFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_BdMPolyFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_BdMPolyFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_BdMPolyFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_BdMPolyFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_BdMPolyFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_BdMPolyFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_BdMPolyFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_BdMPolyFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_BdMPolyFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_BdMPolyFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_BdMPolyFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_BdMPolyFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_BdMPolyFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_BdMPolyFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_BdMPolyFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_BdMPolyFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_BdMPolyFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_BdMPolyFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_BdMPolyFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_BdMPolyFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdMPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BdMPolyFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_BdPolyFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_BdPolyFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_BdPolyFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_BdPolyFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_BdPolyFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_BdPolyFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_BdPolyFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_BdPolyFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_BdPolyFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_BdPolyFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_BdPolyFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_BdPolyFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_BdPolyFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_BdPolyFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_BdPolyFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_BdPolyFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_BdPolyFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_BdPolyFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_BdPolyFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_BdPolyFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_BdPolyFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_BdPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BdPolyFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Boundary PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Boundary LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Boundary PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Boundary PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Boundary LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Boundary PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Boundary PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Boundary LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Boundary PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Boundary GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Boundary CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Boundary CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Boundary MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Boundary MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Boundary MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Boundary MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Boundary MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Boundary MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Boundary MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Boundary MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Boundary MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Boundary(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Boundary MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Box2D PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Box2D LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Box2D PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Box2D PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Box2D LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Box2D PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Box2D PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Box2D LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Box2D PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Box2D GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Box2D CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Box2D CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Box2D MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Box2D MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Box2D MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Box2D MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Box2D MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Box2D MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Box2D MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Box2D MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Box2D MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Box2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Box2D MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Box3D PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Box3D LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Box3D PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Box3D PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Box3D LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Box3D PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Box3D PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Box3D LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Box3D PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Box3D GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Box3D CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Box3D CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Box3D MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Box3D MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Box3D MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Box3D MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Box3D MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Box3D MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Box3D MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Box3D MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Box3D MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Box3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Box3D MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Buffer PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Buffer LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Buffer PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Buffer PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Buffer LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Buffer PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Buffer PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Buffer LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Buffer PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Buffer GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Buffer CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Buffer CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Buffer MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Buffer MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Buffer MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Buffer MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Buffer MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Buffer MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Buffer MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Buffer MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Buffer MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Buffer PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Buffer LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Buffer PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Buffer PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Buffer LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Buffer PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Buffer PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Buffer LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Buffer PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Buffer GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Buffer CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Buffer CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Buffer MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Buffer MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Buffer MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Buffer MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Buffer MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Buffer MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Buffer MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Buffer MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Buffer MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Buffer(foo1.the_geom, 0.5, 5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Buffer MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_BuildArea PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_BuildArea LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_BuildArea PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_BuildArea PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_BuildArea LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_BuildArea PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_BuildArea PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_BuildArea LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_BuildArea PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_BuildArea GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_BuildArea CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_BuildArea CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_BuildArea MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_BuildArea MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_BuildArea MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_BuildArea MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_BuildArea MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_BuildArea MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_BuildArea MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_BuildArea MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_BuildArea MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_BuildArea(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_BuildArea MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Centroid PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Centroid LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Centroid PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Centroid PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Centroid LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Centroid PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Centroid PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Centroid LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Centroid PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Centroid GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Centroid CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Centroid CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Centroid MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Centroid MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Centroid MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Centroid MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Centroid MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Centroid MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Centroid MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Centroid MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Centroid MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Centroid(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Centroid MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Collect LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Collect LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Collect LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Collect MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect PointSet(g1, g2): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect PointSet(g1, g2): End Testing POINT against other types';
		
SELECT 'ST_Collect LineSet(g1, g2): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect LineSet(g1, g2): End Testing LINESTRING against other types';
		
SELECT 'ST_Collect PolySet(g1, g2): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect PolySet(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Collect PointMSet(g1, g2): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect PointMSet(g1, g2): End Testing POINTM against other types';
		
SELECT 'ST_Collect LineMSet(g1, g2): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect LineMSet(g1, g2): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect PolygonMSet(g1, g2): End Testing POLYGONM against other types';
		
SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect PointSet3D(g1, g2): End Testing POINT against other types';
		
SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect LineSet3D(g1, g2): End Testing LINESTRING against other types';
		
SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect PolygonSet3D(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect GCSet3D(g1, g2): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect CurvePolySet(g1, g2): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect CircularStringSet(g1, g2): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect MultiPointSet(g1, g2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect MultiLineSet(g1, g2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect MultiPolySet(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect MultiPointSet3D(g1, g2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect MultiLineSet3D(g1, g2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect MultiPolySet3D(g1, g2): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect MultiPointMSet(g1, g2): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect MultiLineMSet(g1, g2): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Collect PointSet(g1, g2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet(g1, g2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolySet(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect PointMSet(g1, g2): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Collect LineMSet(g1, g2): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Collect PolygonMSet(g1, g2): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Collect PointSet3D(g1, g2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Collect LineSet3D(g1, g2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Collect PolygonSet3D(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect GCSet3D(g1, g2): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Collect CurvePolySet(g1, g2): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Collect CircularStringSet(g1, g2): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Collect MultiPointSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointSet3D(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Collect MultiLineSet3D(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Collect MultiPolySet3D(g1, g2): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Collect MultiPointMSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Collect MultiLineMSet(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Collect MultiPolygonMSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Collect(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Collect(g1, g2)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Collect MultiPolygonMSet(g1, g2): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains PointSet(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains LineSet(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains PolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains PointMSet(geomA, geomB): End Testing POINTM against other types';
		
SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains LineMSet(geomA, geomB): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains PolygonMSet(geomA, geomB): End Testing POLYGONM against other types';
		
SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains PointSet3D(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains LineSet3D(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains PolygonSet3D(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains GCSet3D(geomA, geomB): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains CurvePolySet(geomA, geomB): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains CircularStringSet(geomA, geomB): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains MultiPointSet(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains MultiLineSet(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains MultiPolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains MultiPointMSet(geomA, geomB): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains MultiLineMSet(geomA, geomB): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Contains PointSet(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains PointMSet(geomA, geomB): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Contains LineMSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Contains PolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Contains PointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Contains LineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Contains PolygonSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains GCSet3D(geomA, geomB): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Contains CurvePolySet(geomA, geomB): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Contains CircularStringSet(geomA, geomB): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Contains MultiPointSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Contains MultiLineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Contains MultiPolySet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Contains MultiPointMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Contains MultiLineMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Contains(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Contains(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Contains MultiPolygonMSet(geomA, geomB): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_ConvexHull PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_ConvexHull LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_ConvexHull PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_ConvexHull PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_ConvexHull LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_ConvexHull PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_ConvexHull PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_ConvexHull LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_ConvexHull PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_ConvexHull GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_ConvexHull CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_ConvexHull CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_ConvexHull MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_ConvexHull MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_ConvexHull MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_ConvexHull MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_ConvexHull MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_ConvexHull MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_ConvexHull MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_ConvexHull MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_ConvexHull MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ConvexHull(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ConvexHull MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_CoordDim PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_CoordDim LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_CoordDim PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_CoordDim PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_CoordDim LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_CoordDim PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_CoordDim PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_CoordDim LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_CoordDim PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_CoordDim GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoordDim CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoordDim CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoordDim MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_CoordDim MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_CoordDim MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_CoordDim MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_CoordDim MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_CoordDim MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoordDim MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_CoordDim MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoordDim MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoordDim(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_CoordDim MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing PointSet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy PointSet(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing LineSet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy LineSet(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing PolySet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy PolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy PointMSet(geomA, geomB): End Testing POINTM against other types';
		
SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy LineMSet(geomA, geomB): End Testing LINESTRINGM against other types';
		
SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): End Testing POLYGONM against other types';
		
SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_CoveredBy PointSet(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy PointMSet(geomA, geomB): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_CoveredBy LineMSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy PolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_CoveredBy PointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_CoveredBy LineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_CoveredBy PolygonSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy GCSet3D(geomA, geomB): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_CoveredBy CurvePolySet(geomA, geomB): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy CircularStringSet(geomA, geomB): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_CoveredBy MultiLineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_CoveredBy MultiPolySet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_CoveredBy MultiPointMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_CoveredBy MultiLineMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_CoveredBy(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_CoveredBy(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_CoveredBy MultiPolygonMSet(geomA, geomB): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers PointSet(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers LineSet(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers PolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers PointMSet(geomA, geomB): End Testing POINTM against other types';
		
SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers LineMSet(geomA, geomB): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers PolygonMSet(geomA, geomB): End Testing POLYGONM against other types';
		
SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers PointSet3D(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers LineSet3D(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers PolygonSet3D(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers GCSet3D(geomA, geomB): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers CurvePolySet(geomA, geomB): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers CircularStringSet(geomA, geomB): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers MultiPointSet(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers MultiLineSet(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers MultiPolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers MultiPointMSet(geomA, geomB): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers MultiLineMSet(geomA, geomB): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Covers PointSet(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers PointMSet(geomA, geomB): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Covers LineMSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Covers PolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Covers PointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Covers LineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Covers PolygonSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers GCSet3D(geomA, geomB): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Covers CurvePolySet(geomA, geomB): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Covers CircularStringSet(geomA, geomB): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Covers MultiPointSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Covers MultiLineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Covers MultiPolySet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Covers MultiPointMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Covers MultiLineMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Covers(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Covers(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Covers MultiPolygonMSet(geomA, geomB): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_Crosses PointSet(g1, g2): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses PointSet(g1, g2): End Testing POINT against other types';
		
SELECT 'ST_Crosses LineSet(g1, g2): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses LineSet(g1, g2): End Testing LINESTRING against other types';
		
SELECT 'ST_Crosses PolySet(g1, g2): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses PolySet(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses PointMSet(g1, g2): End Testing POINTM against other types';
		
SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses LineMSet(g1, g2): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses PolygonMSet(g1, g2): End Testing POLYGONM against other types';
		
SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses PointSet3D(g1, g2): End Testing POINT against other types';
		
SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses LineSet3D(g1, g2): End Testing LINESTRING against other types';
		
SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses PolygonSet3D(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses GCSet3D(g1, g2): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses CurvePolySet(g1, g2): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses CircularStringSet(g1, g2): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses MultiPointSet(g1, g2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses MultiLineSet(g1, g2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses MultiPolySet(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses MultiPointSet3D(g1, g2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses MultiLineSet3D(g1, g2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses MultiPolySet3D(g1, g2): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses MultiPointMSet(g1, g2): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses MultiLineMSet(g1, g2): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Crosses PointSet(g1, g2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet(g1, g2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolySet(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses PointMSet(g1, g2): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Crosses LineMSet(g1, g2): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Crosses PolygonMSet(g1, g2): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Crosses PointSet3D(g1, g2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Crosses LineSet3D(g1, g2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Crosses PolygonSet3D(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses GCSet3D(g1, g2): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Crosses CurvePolySet(g1, g2): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Crosses CircularStringSet(g1, g2): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Crosses MultiPointSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointSet3D(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Crosses MultiLineSet3D(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Crosses MultiPolySet3D(g1, g2): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Crosses MultiPointMSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Crosses MultiLineMSet(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Crosses(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Crosses(g1, g2)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Crosses MultiPolygonMSet(g1, g2): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing PointSet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin PointSet(g1, g2, distance): End Testing POINT against other types';
		
SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing LineSet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin LineSet(g1, g2, distance): End Testing LINESTRING against other types';
		
SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing PolySet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin PolySet(g1, g2, distance): End Testing POLYGON against other types';
		
SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin PointMSet(g1, g2, distance): End Testing POINTM against other types';
		
SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin LineMSet(g1, g2, distance): End Testing LINESTRINGM against other types';
		
SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): End Testing POLYGONM against other types';
		
SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin PointSet3D(g1, g2, distance): End Testing POINT against other types';
		
SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin LineSet3D(g1, g2, distance): End Testing LINESTRING against other types';
		
SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): End Testing POLYGON against other types';
		
SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin GCSet3D(g1, g2, distance): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): End Testing MULTIPOINT against other types';
		
SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): End Testing POLYGON against other types';
		
SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): End Testing MULTIPOINT against other types';
		
SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_DWithin PointSet(g1, g2, distance): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet(g1, g2, distance): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolySet(g1, g2, distance): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin PointMSet(g1, g2, distance): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_DWithin LineMSet(g1, g2, distance): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_DWithin PolygonMSet(g1, g2, distance): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_DWithin PointSet3D(g1, g2, distance): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_DWithin LineSet3D(g1, g2, distance): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_DWithin PolygonSet3D(g1, g2, distance): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin GCSet3D(g1, g2, distance): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DWithin CurvePolySet(g1, g2, distance): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_DWithin CircularStringSet(g1, g2, distance): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_DWithin MultiPointSet(g1, g2, distance): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet(g1, g2, distance): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet(g1, g2, distance): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointSet3D(g1, g2, distance): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_DWithin MultiLineSet3D(g1, g2, distance): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_DWithin MultiPolySet3D(g1, g2, distance): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_DWithin MultiPointMSet(g1, g2, distance): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_DWithin MultiLineMSet(g1, g2, distance): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DWithin(foo1.the_geom, foo2.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_DWithin(g1, g2, distance)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_DWithin MultiPolygonMSet(g1, g2, distance): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference PointSet(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference LineSet(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference PolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference PointMSet(geomA, geomB): End Testing POINTM against other types';
		
SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference LineMSet(geomA, geomB): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference PolygonMSet(geomA, geomB): End Testing POLYGONM against other types';
		
SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference PointSet3D(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference LineSet3D(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference PolygonSet3D(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference GCSet3D(geomA, geomB): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference CurvePolySet(geomA, geomB): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference CircularStringSet(geomA, geomB): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference MultiPointSet(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference MultiLineSet(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference MultiPolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference MultiPointMSet(geomA, geomB): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference MultiLineMSet(geomA, geomB): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Difference PointSet(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference PointMSet(geomA, geomB): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Difference LineMSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Difference PolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Difference PointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Difference LineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Difference PolygonSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference GCSet3D(geomA, geomB): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Difference CurvePolySet(geomA, geomB): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Difference CircularStringSet(geomA, geomB): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Difference MultiPointSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Difference MultiLineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Difference MultiPolySet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Difference MultiPointMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Difference MultiLineMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Difference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Difference(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Difference MultiPolygonMSet(geomA, geomB): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_Dimension PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Dimension LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Dimension PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Dimension PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Dimension LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Dimension PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Dimension PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Dimension LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Dimension PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Dimension GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Dimension CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Dimension CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Dimension MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Dimension MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Dimension MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Dimension MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Dimension MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Dimension MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Dimension MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Dimension MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Dimension MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Dimension(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Dimension MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint PointSet(A, B): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint PointSet(A, B): End Testing POINT against other types';
		
SELECT 'ST_Disjoint LineSet(A, B): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint LineSet(A, B): End Testing LINESTRING against other types';
		
SELECT 'ST_Disjoint PolySet(A, B): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint PolySet(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Disjoint PointMSet(A, B): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint PointMSet(A, B): End Testing POINTM against other types';
		
SELECT 'ST_Disjoint LineMSet(A, B): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint LineMSet(A, B): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint PolygonMSet(A, B): End Testing POLYGONM against other types';
		
SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint PointSet3D(A, B): End Testing POINT against other types';
		
SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint LineSet3D(A, B): End Testing LINESTRING against other types';
		
SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint PolygonSet3D(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint GCSet3D(A, B): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint CurvePolySet(A, B): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint CircularStringSet(A, B): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint MultiPointSet(A, B): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint MultiLineSet(A, B): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint MultiPolySet(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint MultiPointSet3D(A, B): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint MultiLineSet3D(A, B): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint MultiPolySet3D(A, B): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint MultiPointMSet(A, B): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint MultiLineMSet(A, B): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Disjoint PointSet(A, B): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet(A, B): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolySet(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint PointMSet(A, B): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Disjoint LineMSet(A, B): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint PolygonMSet(A, B): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Disjoint PointSet3D(A, B): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Disjoint LineSet3D(A, B): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Disjoint PolygonSet3D(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint GCSet3D(A, B): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Disjoint CurvePolySet(A, B): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Disjoint CircularStringSet(A, B): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet(A, B): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet(A, B): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointSet3D(A, B): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Disjoint MultiLineSet3D(A, B): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Disjoint MultiPolySet3D(A, B): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Disjoint MultiPointMSet(A, B): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Disjoint MultiLineMSet(A, B): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Disjoint MultiPolygonMSet(A, B): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Disjoint(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Disjoint(A, B)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Disjoint MultiPolygonMSet(A, B): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_Distance PointSet(g1, g2): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance PointSet(g1, g2): End Testing POINT against other types';
		
SELECT 'ST_Distance LineSet(g1, g2): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance LineSet(g1, g2): End Testing LINESTRING against other types';
		
SELECT 'ST_Distance PolySet(g1, g2): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance PolySet(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Distance PointMSet(g1, g2): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance PointMSet(g1, g2): End Testing POINTM against other types';
		
SELECT 'ST_Distance LineMSet(g1, g2): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance LineMSet(g1, g2): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance PolygonMSet(g1, g2): End Testing POLYGONM against other types';
		
SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance PointSet3D(g1, g2): End Testing POINT against other types';
		
SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance LineSet3D(g1, g2): End Testing LINESTRING against other types';
		
SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance PolygonSet3D(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance GCSet3D(g1, g2): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance CurvePolySet(g1, g2): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance CircularStringSet(g1, g2): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance MultiPointSet(g1, g2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance MultiLineSet(g1, g2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance MultiPolySet(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance MultiPointSet3D(g1, g2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance MultiLineSet3D(g1, g2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance MultiPolySet3D(g1, g2): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance MultiPointMSet(g1, g2): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance MultiLineMSet(g1, g2): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Distance PointSet(g1, g2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet(g1, g2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolySet(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance PointMSet(g1, g2): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Distance LineMSet(g1, g2): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance PolygonMSet(g1, g2): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance PointSet3D(g1, g2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Distance LineSet3D(g1, g2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance PolygonSet3D(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance GCSet3D(g1, g2): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance CurvePolySet(g1, g2): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance CircularStringSet(g1, g2): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance MultiPointSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointSet3D(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance MultiLineSet3D(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance MultiPolySet3D(g1, g2): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance MultiPointMSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance MultiLineMSet(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance MultiPolygonMSet(g1, g2): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): End Testing POINT against other types';
		
SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): End Testing LINESTRING against other types';
		
SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): End Testing POLYGON against other types';
		
SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): End Testing POINTM against other types';
		
SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): End Testing POLYGONM against other types';
		
SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): End Testing POINT against other types';
		
SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): End Testing LINESTRING against other types';
		
SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): End Testing POLYGON against other types';
		
SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): End Testing POLYGON against other types';
		
SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Distance_Sphere PointSet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolySet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere PointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Sphere LineMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Sphere PointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Sphere LineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere PolygonSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere GCSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Sphere CurvePolySet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere CircularStringSet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineSet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolySet3D(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPointMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiLineMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Sphere(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Sphere(pointlonlatA, pointlonlatB)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Sphere MultiPolygonMSet(pointlonlatA, pointlonlatB): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing POINT against other types';
		
SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing LINESTRING against other types';
		
SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing POLYGON against other types';
		
SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing POINTM against other types';
		
SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing POLYGONM against other types';
		
SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing POINT against other types';
		
SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing LINESTRING against other types';
		
SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing POLYGON against other types';
		
SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing POLYGON against other types';
		
SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Distance_Spheroid PointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid PointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid LineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Distance_Spheroid PointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Distance_Spheroid LineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid PolygonSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid GCSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Distance_Spheroid CurvePolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid CircularStringSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineSet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolySet3D(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPointMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiLineMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Distance_Spheroid(foo1.the_geom, foo2.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Distance_Spheroid(pointlonlatA, pointlonlatB, measurement_spheroid)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Distance_Spheroid MultiPolygonMSet(pointlonlatA, pointlonlatB, measurement_spheroid): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_DropBBox PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_DropBBox LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_DropBBox PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_DropBBox PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_DropBBox LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_DropBBox PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_DropBBox PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_DropBBox LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_DropBBox PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_DropBBox GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DropBBox CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_DropBBox CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_DropBBox MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_DropBBox MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_DropBBox MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_DropBBox MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_DropBBox MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_DropBBox MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_DropBBox MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_DropBBox MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DropBBox MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_DropBBox(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_DropBBox MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Dump PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Dump LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Dump LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Dump PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Dump PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Dump LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Dump LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Dump PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Dump PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Dump LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Dump PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Dump GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Dump CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Dump CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Dump MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Dump MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Dump MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Dump MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Dump MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Dump MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Dump MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Dump MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Dump MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Dump(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Dump MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_DumpRings PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_DumpRings LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_DumpRings PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_DumpRings PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_DumpRings LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_DumpRings PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_DumpRings PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_DumpRings LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_DumpRings PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_DumpRings GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_DumpRings CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_DumpRings CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_DumpRings MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_DumpRings MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_DumpRings MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_DumpRings MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_DumpRings MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_DumpRings MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_DumpRings MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_DumpRings MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_DumpRings MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_DumpRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_DumpRings MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_EndPoint PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_EndPoint LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_EndPoint PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_EndPoint PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_EndPoint LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_EndPoint PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_EndPoint PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_EndPoint LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_EndPoint PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_EndPoint GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_EndPoint CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_EndPoint CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_EndPoint MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_EndPoint MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_EndPoint MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_EndPoint MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_EndPoint MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_EndPoint MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_EndPoint MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_EndPoint MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_EndPoint MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_EndPoint(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_EndPoint MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Envelope PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Envelope LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Envelope PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Envelope PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Envelope LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Envelope PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Envelope PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Envelope LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Envelope PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Envelope GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Envelope CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Envelope CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Envelope MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Envelope MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Envelope MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Envelope MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Envelope MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Envelope MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Envelope MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Envelope MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Envelope MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Envelope(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Envelope MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals PointSet(A, B): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals PointSet(A, B): End Testing POINT against other types';
		
SELECT 'ST_Equals LineSet(A, B): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals LineSet(A, B): End Testing LINESTRING against other types';
		
SELECT 'ST_Equals PolySet(A, B): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals PolySet(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Equals PointMSet(A, B): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals PointMSet(A, B): End Testing POINTM against other types';
		
SELECT 'ST_Equals LineMSet(A, B): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals LineMSet(A, B): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Equals PolygonMSet(A, B): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals PolygonMSet(A, B): End Testing POLYGONM against other types';
		
SELECT 'ST_Equals PointSet3D(A, B): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals PointSet3D(A, B): End Testing POINT against other types';
		
SELECT 'ST_Equals LineSet3D(A, B): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals LineSet3D(A, B): End Testing LINESTRING against other types';
		
SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals PolygonSet3D(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Equals GCSet3D(A, B): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals GCSet3D(A, B): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Equals CurvePolySet(A, B): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals CurvePolySet(A, B): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Equals CircularStringSet(A, B): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals CircularStringSet(A, B): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Equals MultiPointSet(A, B): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals MultiPointSet(A, B): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Equals MultiLineSet(A, B): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals MultiLineSet(A, B): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Equals MultiPolySet(A, B): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals MultiPolySet(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals MultiPointSet3D(A, B): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals MultiLineSet3D(A, B): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals MultiPolySet3D(A, B): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals MultiPointMSet(A, B): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals MultiLineMSet(A, B): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Equals PointSet(A, B): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet(A, B): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolySet(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals PointMSet(A, B): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Equals LineMSet(A, B): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Equals PolygonMSet(A, B): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Equals PointSet3D(A, B): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Equals LineSet3D(A, B): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Equals PolygonSet3D(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals GCSet3D(A, B): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Equals CurvePolySet(A, B): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Equals CircularStringSet(A, B): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Equals MultiPointSet(A, B): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet(A, B): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointSet3D(A, B): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Equals MultiLineSet3D(A, B): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Equals MultiPolySet3D(A, B): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Equals MultiPointMSet(A, B): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Equals MultiLineMSet(A, B): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Equals MultiPolygonMSet(A, B): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Equals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Equals(A, B)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Equals MultiPolygonMSet(A, B): End Testing MULTIPOLYGONM against other types';
		SELECT  'Starting ST_Estimated_Extent(schema_name, table_name, geocolumn_name)';BEGIN; 
SELECT  ST_Estimated_Extent('monkey', 'monkey', 'monkey');
COMMIT;
SELECT  'Ending ST_Estimated_Extent(schema_name, table_name, geocolumn_name)';
	SELECT  'Starting ST_Estimated_Extent(table_name, geocolumn_name)';BEGIN; 
SELECT  ST_Estimated_Extent('monkey', 'monkey');
COMMIT;
SELECT  'Ending ST_Estimated_Extent(table_name, geocolumn_name)';
	
	SELECT 'ST_Expand PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Expand LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Expand LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Expand PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Expand PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Expand LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Expand LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Expand PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Expand PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Expand LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Expand PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Expand GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Expand CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Expand CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Expand MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Expand MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Expand MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Expand MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Expand MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Expand MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Expand MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Expand MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Expand MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Expand(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Expand PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Expand LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Expand LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Expand PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Expand PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Expand LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Expand LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Expand PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Expand PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Expand LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Expand PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Expand GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Expand CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Expand CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Expand MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Expand MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Expand MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Expand MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Expand MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Expand MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Expand MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Expand MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Expand MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Expand PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Expand LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Expand LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Expand PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Expand PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Expand LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Expand LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Expand PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Expand PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Expand LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Expand PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Expand GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Expand CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Expand CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Expand MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Expand MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Expand MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Expand MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Expand MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Expand MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Expand MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Expand MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Expand MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Expand(foo1.the_geom, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Expand MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Extent PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Extent LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Extent LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Extent PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Extent PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Extent LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Extent LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Extent PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Extent PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Extent LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Extent PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Extent GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Extent CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Extent CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Extent MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Extent MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Extent MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Extent MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Extent MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Extent MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Extent MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Extent MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Extent MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Extent(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Extent3D PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Extent3D LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Extent3D PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Extent3D PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Extent3D LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Extent3D PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Extent3D PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Extent3D LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Extent3D PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Extent3D GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Extent3D CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Extent3D CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Extent3D MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Extent3D MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Extent3D MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Extent3D MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Extent3D MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Extent3D MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Extent3D MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Extent3D MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Extent3D MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Extent3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Extent3D MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_ExteriorRing PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_ExteriorRing LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_ExteriorRing PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_ExteriorRing PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_ExteriorRing LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_ExteriorRing PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_ExteriorRing PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_ExteriorRing LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_ExteriorRing PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_ExteriorRing GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_ExteriorRing CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_ExteriorRing CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_ExteriorRing MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_ExteriorRing MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_ExteriorRing MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_ExteriorRing MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_ExteriorRing MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_ExteriorRing MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_ExteriorRing MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_ExteriorRing MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_ExteriorRing MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_ExteriorRing(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ExteriorRing MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_ForceRHR PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_ForceRHR LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_ForceRHR PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_ForceRHR PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_ForceRHR LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_ForceRHR PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_ForceRHR PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_ForceRHR LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_ForceRHR PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_ForceRHR GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_ForceRHR CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_ForceRHR CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_ForceRHR MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_ForceRHR MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_ForceRHR MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_ForceRHR MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_ForceRHR MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_ForceRHR MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_ForceRHR MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_ForceRHR MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_ForceRHR MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_ForceRHR(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ForceRHR MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Force_2D PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Force_2D LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Force_2D PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_2D PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Force_2D LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Force_2D PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Force_2D PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Force_2D LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Force_2D PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_2D GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Force_2D CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Force_2D CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Force_2D MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Force_2D MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Force_2D MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_2D MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Force_2D MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Force_2D MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Force_2D MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Force_2D MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Force_2D MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_2D(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_2D MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Force_3D PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Force_3D LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Force_3D PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_3D PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Force_3D LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Force_3D PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Force_3D PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Force_3D LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Force_3D PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_3D GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Force_3D CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Force_3D CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Force_3D MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Force_3D MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Force_3D MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_3D MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Force_3D MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Force_3D MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Force_3D MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Force_3D MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Force_3D MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3D(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3D MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Force_3DM PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Force_3DM LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Force_3DM PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_3DM PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Force_3DM LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Force_3DM PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Force_3DM PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Force_3DM LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Force_3DM PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_3DM GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Force_3DM CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Force_3DM CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Force_3DM MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Force_3DM MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Force_3DM MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_3DM MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Force_3DM MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Force_3DM MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Force_3DM MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Force_3DM MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Force_3DM MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DM(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DM MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Force_3DZ PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Force_3DZ LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Force_3DZ PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_3DZ PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Force_3DZ LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Force_3DZ PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Force_3DZ PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Force_3DZ LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Force_3DZ PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_3DZ GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Force_3DZ CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Force_3DZ CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Force_3DZ MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Force_3DZ MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Force_3DZ MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_3DZ MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Force_3DZ MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Force_3DZ MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Force_3DZ MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Force_3DZ MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Force_3DZ MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_3DZ(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_3DZ MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Force_4D PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Force_4D LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Force_4D PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_4D PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Force_4D LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Force_4D PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Force_4D PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Force_4D LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Force_4D PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_4D GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Force_4D CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Force_4D CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Force_4D MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Force_4D MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Force_4D MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_4D MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Force_4D MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Force_4D MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Force_4D MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Force_4D MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Force_4D MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_4D(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_4D MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Force_Collection PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Force_Collection LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Force_Collection PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_Collection PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Force_Collection LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Force_Collection PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Force_Collection PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Force_Collection LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Force_Collection PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_Collection GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Force_Collection CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Force_Collection CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Force_Collection MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Force_Collection MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Force_Collection MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Force_Collection MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Force_Collection MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Force_Collection MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Force_Collection MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Force_Collection MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Force_Collection MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Force_Collection(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Force_Collection MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeoHash PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeoHash LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeoHash PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeoHash PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeoHash LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeoHash PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeoHash PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeoHash LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeoHash PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeoHash GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeoHash CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeoHash CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeoHash MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeoHash MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeoHash MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeoHash MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeoHash MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeoHash MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeoHash MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeoHash MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeoHash MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeoHash PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeoHash LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeoHash PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeoHash PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeoHash LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeoHash PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeoHash PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeoHash LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeoHash PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeoHash GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeoHash CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeoHash CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeoHash MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeoHash MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeoHash MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeoHash MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeoHash MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeoHash MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeoHash MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeoHash MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeoHash MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_GeoHash(foo1.the_geom, 3)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeoHash MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeomCollFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeomCollFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomCollFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomCollFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeomCollFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeomCollFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeomCollFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeomCollFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomCollFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomCollFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeomCollFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeomCollFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeomCollFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomCollFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomCollFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomCollFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomCollFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomCollFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeomCollFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeomCollFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeomCollFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeomCollFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeomCollFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomCollFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomCollFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeomCollFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeomCollFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeomCollFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeomCollFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomCollFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomCollFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeomCollFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeomCollFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeomCollFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomCollFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomCollFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomCollFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomCollFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomCollFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeomCollFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeomCollFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeomCollFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomCollFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomCollFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeomFromEWKB PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeomFromEWKB LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomFromEWKB PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromEWKB PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeomFromEWKB LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeomFromEWKB PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeomFromEWKB PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeomFromEWKB LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomFromEWKB PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromEWKB GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeomFromEWKB CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeomFromEWKB CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeomFromEWKB MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomFromEWKB MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomFromEWKB MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromEWKB MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomFromEWKB MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomFromEWKB MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeomFromEWKB MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeomFromEWKB MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeomFromEWKB MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKB(ST_AsEWKB(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKB MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeomFromEWKT PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeomFromEWKT LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomFromEWKT PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromEWKT PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeomFromEWKT LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeomFromEWKT PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeomFromEWKT PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeomFromEWKT LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomFromEWKT PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromEWKT GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeomFromEWKT CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeomFromEWKT CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeomFromEWKT MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomFromEWKT MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomFromEWKT MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromEWKT MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomFromEWKT MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomFromEWKT MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeomFromEWKT MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeomFromEWKT MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeomFromEWKT MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromEWKT(ST_AsEWKT(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromEWKT MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeomFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeomFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeomFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeomFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeomFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeomFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeomFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeomFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeomFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeomFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeomFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeomFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeomFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeomFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeomFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeomFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeomFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeomFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeomFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeomFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeomFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeomFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeomFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeomFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeomFromWKB PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeomFromWKB LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomFromWKB PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromWKB PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeomFromWKB LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeomFromWKB PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeomFromWKB PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeomFromWKB LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomFromWKB PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromWKB GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeomFromWKB CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeomFromWKB CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeomFromWKB MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomFromWKB MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomFromWKB MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromWKB MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomFromWKB MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomFromWKB MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeomFromWKB MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeomFromWKB MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeomFromWKB MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeomFromWKB PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeomFromWKB LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomFromWKB PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromWKB PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeomFromWKB LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeomFromWKB PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeomFromWKB PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeomFromWKB LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeomFromWKB PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromWKB GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeomFromWKB CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeomFromWKB CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeomFromWKB MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomFromWKB MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomFromWKB MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeomFromWKB MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeomFromWKB MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeomFromWKB MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeomFromWKB MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeomFromWKB MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeomFromWKB MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeomFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeomFromWKB MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeometryFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeometryFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeometryFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeometryFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeometryFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeometryFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeometryFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeometryFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeometryFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeometryFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeometryFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeometryFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeometryFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeometryFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeometryFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeometryFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeometryFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeometryFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeometryFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeometryFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeometryFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeometryFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeometryFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeometryFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeometryFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeometryFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeometryFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeometryFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeometryFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeometryFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeometryFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeometryFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeometryFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeometryFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeometryFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeometryFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeometryFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeometryFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeometryFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeometryFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeometryFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeometryFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeometryN PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeometryN LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeometryN PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeometryN PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeometryN LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeometryN PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeometryN PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeometryN LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeometryN PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeometryN GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeometryN CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeometryN CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeometryN MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeometryN MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeometryN MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeometryN MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeometryN MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeometryN MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeometryN MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeometryN MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeometryN MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_GeometryN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryN MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_GeometryType PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_GeometryType LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeometryType PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeometryType PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_GeometryType LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_GeometryType PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_GeometryType PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_GeometryType LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_GeometryType PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeometryType GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_GeometryType CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_GeometryType CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_GeometryType MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeometryType MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeometryType MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_GeometryType MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_GeometryType MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_GeometryType MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_GeometryType MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_GeometryType MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_GeometryType MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_GeometryType(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_GeometryType MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_HasArc PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_HasArc LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_HasArc PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_HasArc PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_HasArc LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_HasArc PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_HasArc PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_HasArc LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_HasArc PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_HasArc GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_HasArc CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_HasArc CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_HasArc MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_HasArc MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_HasArc MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_HasArc MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_HasArc MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_HasArc MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_HasArc MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_HasArc MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_HasArc MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_HasArc(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_HasArc MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_HasBBox PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_HasBBox LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_HasBBox PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_HasBBox PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_HasBBox LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_HasBBox PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_HasBBox PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_HasBBox LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_HasBBox PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_HasBBox GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_HasBBox CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_HasBBox CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_HasBBox MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_HasBBox MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_HasBBox MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_HasBBox MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_HasBBox MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_HasBBox MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_HasBBox MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_HasBBox MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_HasBBox MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_HasBBox(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_HasBBox MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_InteriorRingN PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_InteriorRingN LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_InteriorRingN PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_InteriorRingN PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_InteriorRingN LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_InteriorRingN PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_InteriorRingN PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_InteriorRingN LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_InteriorRingN PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_InteriorRingN GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_InteriorRingN CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_InteriorRingN CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_InteriorRingN MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_InteriorRingN MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_InteriorRingN MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_InteriorRingN MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_InteriorRingN MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_InteriorRingN MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_InteriorRingN MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_InteriorRingN MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_InteriorRingN MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_InteriorRingN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_InteriorRingN MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection PointSet(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection LineSet(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection PolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection PointMSet(geomA, geomB): End Testing POINTM against other types';
		
SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection LineMSet(geomA, geomB): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection PolygonMSet(geomA, geomB): End Testing POLYGONM against other types';
		
SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection PointSet3D(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection LineSet3D(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection GCSet3D(geomA, geomB): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection CurvePolySet(geomA, geomB): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection CircularStringSet(geomA, geomB): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection MultiPointSet(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection MultiLineSet(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection MultiPolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Intersection PointSet(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection PointMSet(geomA, geomB): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Intersection LineMSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersection PolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersection PointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Intersection LineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersection PolygonSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection GCSet3D(geomA, geomB): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersection CurvePolySet(geomA, geomB): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersection CircularStringSet(geomA, geomB): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersection MultiPointSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersection MultiLineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersection MultiPolySet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersection MultiPointMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersection MultiLineMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Intersection(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersection(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersection MultiPolygonMSet(geomA, geomB): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_Intersects PointSet(A, B): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects PointSet(A, B): End Testing POINT against other types';
		
SELECT 'ST_Intersects LineSet(A, B): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects LineSet(A, B): End Testing LINESTRING against other types';
		
SELECT 'ST_Intersects PolySet(A, B): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects PolySet(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Intersects PointMSet(A, B): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects PointMSet(A, B): End Testing POINTM against other types';
		
SELECT 'ST_Intersects LineMSet(A, B): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects LineMSet(A, B): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects PolygonMSet(A, B): End Testing POLYGONM against other types';
		
SELECT 'ST_Intersects PointSet3D(A, B): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects PointSet3D(A, B): End Testing POINT against other types';
		
SELECT 'ST_Intersects LineSet3D(A, B): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects LineSet3D(A, B): End Testing LINESTRING against other types';
		
SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects PolygonSet3D(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Intersects GCSet3D(A, B): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects GCSet3D(A, B): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects CurvePolySet(A, B): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects CircularStringSet(A, B): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects MultiPointSet(A, B): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects MultiLineSet(A, B): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects MultiPolySet(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects MultiPointSet3D(A, B): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects MultiLineSet3D(A, B): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects MultiPolySet3D(A, B): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects MultiPointMSet(A, B): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects MultiLineMSet(A, B): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Intersects PointSet(A, B): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet(A, B): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolySet(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects PointMSet(A, B): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Intersects LineMSet(A, B): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Intersects PolygonMSet(A, B): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Intersects PointSet3D(A, B): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Intersects LineSet3D(A, B): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Intersects PolygonSet3D(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects GCSet3D(A, B): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Intersects CurvePolySet(A, B): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Intersects CircularStringSet(A, B): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Intersects MultiPointSet(A, B): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet(A, B): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointSet3D(A, B): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Intersects MultiLineSet3D(A, B): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Intersects MultiPolySet3D(A, B): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Intersects MultiPointMSet(A, B): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Intersects MultiLineMSet(A, B): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Intersects MultiPolygonMSet(A, B): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Intersects(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Intersects(A, B)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Intersects MultiPolygonMSet(A, B): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_IsClosed PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_IsClosed LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_IsClosed PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsClosed PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_IsClosed LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_IsClosed PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_IsClosed PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_IsClosed LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_IsClosed PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsClosed GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_IsClosed CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_IsClosed CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_IsClosed MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_IsClosed MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_IsClosed MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsClosed MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_IsClosed MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_IsClosed MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_IsClosed MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_IsClosed MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_IsClosed MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_IsClosed(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsClosed MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_IsEmpty PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_IsEmpty LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_IsEmpty PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsEmpty PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_IsEmpty LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_IsEmpty PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_IsEmpty PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_IsEmpty LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_IsEmpty PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsEmpty GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_IsEmpty CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_IsEmpty CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_IsEmpty MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_IsEmpty MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_IsEmpty MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsEmpty MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_IsEmpty MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_IsEmpty MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_IsEmpty MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_IsEmpty MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_IsEmpty MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_IsEmpty(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsEmpty MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_IsRing PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_IsRing LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_IsRing PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsRing PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_IsRing LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_IsRing PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_IsRing PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_IsRing LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_IsRing PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsRing GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_IsRing CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_IsRing CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_IsRing MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_IsRing MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_IsRing MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsRing MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_IsRing MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_IsRing MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_IsRing MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_IsRing MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_IsRing MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_IsRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsRing MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_IsSimple PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_IsSimple LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_IsSimple PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsSimple PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_IsSimple LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_IsSimple PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_IsSimple PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_IsSimple LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_IsSimple PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsSimple GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_IsSimple CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_IsSimple CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_IsSimple MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_IsSimple MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_IsSimple MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsSimple MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_IsSimple MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_IsSimple MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_IsSimple MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_IsSimple MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_IsSimple MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_IsSimple(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsSimple MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_IsValid PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_IsValid LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_IsValid PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsValid PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_IsValid LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_IsValid PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_IsValid PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_IsValid LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_IsValid PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsValid GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_IsValid CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_IsValid CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_IsValid MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_IsValid MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_IsValid MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsValid MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_IsValid MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_IsValid MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_IsValid MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_IsValid MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_IsValid MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_IsValid(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValid MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_IsValidReason PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_IsValidReason LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_IsValidReason PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsValidReason PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_IsValidReason LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_IsValidReason PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_IsValidReason PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_IsValidReason LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_IsValidReason PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsValidReason GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_IsValidReason CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_IsValidReason CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_IsValidReason MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_IsValidReason MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_IsValidReason MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_IsValidReason MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_IsValidReason MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_IsValidReason MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_IsValidReason MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_IsValidReason MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_IsValidReason MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_IsValidReason(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_IsValidReason MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Length PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Length LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Length LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Length PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Length LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Length LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Length PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Length PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Length LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Length PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Length CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Length CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Length MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Length MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Length MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Length MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Length MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Length MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Length MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Length MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Length(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Length2D PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Length2D LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Length2D PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length2D PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Length2D LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Length2D PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Length2D PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Length2D LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Length2D PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length2D GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Length2D CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Length2D CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Length2D MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Length2D MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Length2D MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length2D MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Length2D MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Length2D MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Length2D MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Length2D MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Length2D MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Length2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Length2D_Spheroid PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Length2D_Spheroid LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Length2D_Spheroid PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length2D_Spheroid PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Length2D_Spheroid LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Length2D_Spheroid PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Length2D_Spheroid PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Length2D_Spheroid LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Length2D_Spheroid PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length2D_Spheroid GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Length2D_Spheroid CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Length2D_Spheroid CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Length2D_Spheroid MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Length2D_Spheroid MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Length2D_Spheroid MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length2D_Spheroid MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Length2D_Spheroid MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Length2D_Spheroid MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Length2D_Spheroid MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Length2D_Spheroid MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Length2D_Spheroid MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Length2D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length2D_Spheroid MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Length3D PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Length3D LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Length3D PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length3D PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Length3D LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Length3D PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Length3D PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Length3D LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Length3D PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length3D GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Length3D CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Length3D CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Length3D MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Length3D MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Length3D MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length3D MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Length3D MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Length3D MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Length3D MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Length3D MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Length3D MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Length3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Length3D_Spheroid PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Length3D_Spheroid LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Length3D_Spheroid PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length3D_Spheroid PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Length3D_Spheroid LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Length3D_Spheroid PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Length3D_Spheroid PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Length3D_Spheroid LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Length3D_Spheroid PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length3D_Spheroid GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Length3D_Spheroid CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Length3D_Spheroid CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Length3D_Spheroid MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Length3D_Spheroid MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Length3D_Spheroid MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length3D_Spheroid MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Length3D_Spheroid MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Length3D_Spheroid MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Length3D_Spheroid MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Length3D_Spheroid MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Length3D_Spheroid MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Length3D_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length3D_Spheroid MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Length_Spheroid PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Length_Spheroid LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Length_Spheroid PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length_Spheroid PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Length_Spheroid LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Length_Spheroid PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Length_Spheroid PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Length_Spheroid LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Length_Spheroid PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length_Spheroid GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Length_Spheroid CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Length_Spheroid CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Length_Spheroid MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Length_Spheroid MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Length_Spheroid MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Length_Spheroid MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Length_Spheroid MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Length_Spheroid MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Length_Spheroid MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Length_Spheroid MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Length_Spheroid MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Length_Spheroid(foo1.the_geom, 'SPHEROID["GRS_1980",6378137,298.257222101]')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Length_Spheroid MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing PointSet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): End Testing POINT against other types';
		
SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing LineSet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): End Testing LINESTRING against other types';
		
SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing PolySet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): End Testing POLYGON against other types';
		
SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): End Testing POINTM against other types';
		
SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): End Testing LINESTRINGM against other types';
		
SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): End Testing POLYGONM against other types';
		
SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): End Testing POINT against other types';
		
SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): End Testing LINESTRING against other types';
		
SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): End Testing POLYGON against other types';
		
SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): End Testing POLYGON against other types';
		
SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_LineCrossingDirection PointSet(linestringA, linestringB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet(linestringA, linestringB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolySet(linestringA, linestringB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection PointMSet(linestringA, linestringB): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection LineMSet(linestringA, linestringB): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonMSet(linestringA, linestringB): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_LineCrossingDirection PointSet3D(linestringA, linestringB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_LineCrossingDirection LineSet3D(linestringA, linestringB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection PolygonSet3D(linestringA, linestringB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection GCSet3D(linestringA, linestringB): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineCrossingDirection CurvePolySet(linestringA, linestringB): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection CircularStringSet(linestringA, linestringB): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet(linestringA, linestringB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet(linestringA, linestringB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet(linestringA, linestringB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointSet3D(linestringA, linestringB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineSet3D(linestringA, linestringB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolySet3D(linestringA, linestringB): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPointMSet(linestringA, linestringB): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiLineMSet(linestringA, linestringB): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_LineCrossingDirection(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LineCrossingDirection(linestringA, linestringB)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LineCrossingDirection MultiPolygonMSet(linestringA, linestringB): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_LineFromMultiPoint PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_LineFromMultiPoint LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineFromMultiPoint PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromMultiPoint PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_LineFromMultiPoint LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_LineFromMultiPoint PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_LineFromMultiPoint PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_LineFromMultiPoint LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineFromMultiPoint PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromMultiPoint GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineFromMultiPoint CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineFromMultiPoint CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineFromMultiPoint MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineFromMultiPoint MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineFromMultiPoint MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromMultiPoint MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineFromMultiPoint MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineFromMultiPoint MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineFromMultiPoint MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_LineFromMultiPoint MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineFromMultiPoint MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromMultiPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromMultiPoint MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_LineFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_LineFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_LineFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_LineFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_LineFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_LineFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_LineFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_LineFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_LineFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_LineFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_LineFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_LineFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_LineFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_LineFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_LineFromWKB PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_LineFromWKB LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineFromWKB PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromWKB PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_LineFromWKB LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_LineFromWKB PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_LineFromWKB PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_LineFromWKB LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineFromWKB PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromWKB GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineFromWKB CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineFromWKB CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineFromWKB MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineFromWKB MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineFromWKB MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromWKB MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineFromWKB MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineFromWKB MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineFromWKB MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_LineFromWKB MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineFromWKB MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_LineFromWKB PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_LineFromWKB LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineFromWKB PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromWKB PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_LineFromWKB LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_LineFromWKB PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_LineFromWKB PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_LineFromWKB LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineFromWKB PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromWKB GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineFromWKB CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineFromWKB CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineFromWKB MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineFromWKB MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineFromWKB MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineFromWKB MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineFromWKB MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineFromWKB MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineFromWKB MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_LineFromWKB MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineFromWKB MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineFromWKB(ST_AsBinary(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineFromWKB MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_LineMerge PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_LineMerge LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineMerge PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineMerge PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_LineMerge LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_LineMerge PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_LineMerge PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_LineMerge LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineMerge PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineMerge GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineMerge CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineMerge CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineMerge MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineMerge MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineMerge MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineMerge MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineMerge MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineMerge MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineMerge MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_LineMerge MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineMerge MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineMerge(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineMerge MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_LineToCurve PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_LineToCurve LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineToCurve PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineToCurve PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_LineToCurve LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_LineToCurve PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_LineToCurve PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_LineToCurve LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LineToCurve PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineToCurve GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LineToCurve CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_LineToCurve CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_LineToCurve MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineToCurve MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineToCurve MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LineToCurve MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LineToCurve MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LineToCurve MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_LineToCurve MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_LineToCurve MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LineToCurve MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LineToCurve(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LineToCurve MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Line_Interpolate_Point PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Line_Interpolate_Point LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Line_Interpolate_Point PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Line_Interpolate_Point PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Line_Interpolate_Point LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Interpolate_Point PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Line_Interpolate_Point PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Line_Interpolate_Point LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Line_Interpolate_Point PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Line_Interpolate_Point GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Interpolate_Point CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Interpolate_Point CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Interpolate_Point MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Interpolate_Point MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Interpolate_Point MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Line_Interpolate_Point MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Interpolate_Point MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Interpolate_Point MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Interpolate_Point MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Interpolate_Point MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Interpolate_Point MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Interpolate_Point(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Interpolate_Point MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): End Testing POINT against other types';
		
SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): End Testing LINESTRING against other types';
		
SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): End Testing POLYGON against other types';
		
SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): End Testing POINTM against other types';
		
SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): End Testing POLYGONM against other types';
		
SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): End Testing POINT against other types';
		
SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): End Testing LINESTRING against other types';
		
SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): End Testing POLYGON against other types';
		
SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): End Testing POLYGON against other types';
		
SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Line_Locate_Point PointSet(a_linestring, a_point): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet(a_linestring, a_point): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolySet(a_linestring, a_point): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point PointMSet(a_linestring, a_point): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point LineMSet(a_linestring, a_point): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonMSet(a_linestring, a_point): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Line_Locate_Point PointSet3D(a_linestring, a_point): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Line_Locate_Point LineSet3D(a_linestring, a_point): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point PolygonSet3D(a_linestring, a_point): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point GCSet3D(a_linestring, a_point): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Locate_Point CurvePolySet(a_linestring, a_point): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point CircularStringSet(a_linestring, a_point): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet(a_linestring, a_point): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet(a_linestring, a_point): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet(a_linestring, a_point): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointSet3D(a_linestring, a_point): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineSet3D(a_linestring, a_point): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolySet3D(a_linestring, a_point): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPointMSet(a_linestring, a_point): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiLineMSet(a_linestring, a_point): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Line_Locate_Point(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Line_Locate_Point(a_linestring, a_point)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Line_Locate_Point MultiPolygonMSet(a_linestring, a_point): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_Line_Substring PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Line_Substring LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Line_Substring PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Line_Substring PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Line_Substring LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Line_Substring PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Line_Substring PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Line_Substring LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Line_Substring PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Line_Substring GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Line_Substring CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Line_Substring CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Line_Substring MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Substring MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Substring MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Line_Substring MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Line_Substring MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Line_Substring MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Line_Substring MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Line_Substring MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Line_Substring MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Line_Substring(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Line_Substring MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing PointSet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): End Testing POINT against other types';
		
SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing LineSet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): End Testing LINESTRING against other types';
		
SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing PolySet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): End Testing POLYGON against other types';
		
SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): End Testing POINTM against other types';
		
SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): End Testing LINESTRINGM against other types';
		
SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): End Testing POLYGONM against other types';
		
SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): End Testing POINT against other types';
		
SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): End Testing LINESTRING against other types';
		
SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): End Testing POLYGON against other types';
		
SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): End Testing MULTIPOINT against other types';
		
SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): End Testing POLYGON against other types';
		
SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): End Testing MULTIPOINT against other types';
		
SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_LinestringFromWKB PointSet(WKT, srid): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet(WKT, srid): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolySet(WKT, srid): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB PointMSet(WKT, srid): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB LineMSet(WKT, srid): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonMSet(WKT, srid): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_LinestringFromWKB PointSet3D(WKT, srid): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_LinestringFromWKB LineSet3D(WKT, srid): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB PolygonSet3D(WKT, srid): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB GCSet3D(WKT, srid): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LinestringFromWKB CurvePolySet(WKT, srid): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB CircularStringSet(WKT, srid): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet(WKT, srid): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet(WKT, srid): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet(WKT, srid): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointSet3D(WKT, srid): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineSet3D(WKT, srid): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolySet3D(WKT, srid): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPointMSet(WKT, srid): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiLineMSet(WKT, srid): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LinestringFromWKB(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_LinestringFromWKB(WKT, srid)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_LinestringFromWKB MultiPolygonMSet(WKT, srid): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_LocateBetweenElevations PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_LocateBetweenElevations LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LocateBetweenElevations PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LocateBetweenElevations PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_LocateBetweenElevations LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_LocateBetweenElevations PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_LocateBetweenElevations PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_LocateBetweenElevations LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_LocateBetweenElevations PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_LocateBetweenElevations GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_LocateBetweenElevations CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_LocateBetweenElevations CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_LocateBetweenElevations MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LocateBetweenElevations MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LocateBetweenElevations MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_LocateBetweenElevations MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_LocateBetweenElevations MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_LocateBetweenElevations MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_LocateBetweenElevations MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_LocateBetweenElevations MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_LocateBetweenElevations MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_LocateBetweenElevations(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_LocateBetweenElevations MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Locate_Along_Measure PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Locate_Along_Measure LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Locate_Along_Measure PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Locate_Along_Measure PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Locate_Along_Measure LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Locate_Along_Measure PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Locate_Along_Measure PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Locate_Along_Measure LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Locate_Along_Measure PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Locate_Along_Measure GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Locate_Along_Measure CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Locate_Along_Measure CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Locate_Along_Measure MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Locate_Along_Measure MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Locate_Along_Measure MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Locate_Along_Measure MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Locate_Along_Measure MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Locate_Along_Measure MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Locate_Along_Measure MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Locate_Along_Measure MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Locate_Along_Measure MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Along_Measure(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Along_Measure MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Locate_Between_Measures PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Locate_Between_Measures LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Locate_Between_Measures PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Locate_Between_Measures PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Locate_Between_Measures LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Locate_Between_Measures PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Locate_Between_Measures PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Locate_Between_Measures LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Locate_Between_Measures PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Locate_Between_Measures GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Locate_Between_Measures CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Locate_Between_Measures CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Locate_Between_Measures MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Locate_Between_Measures MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Locate_Between_Measures MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Locate_Between_Measures MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Locate_Between_Measures MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Locate_Between_Measures MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Locate_Between_Measures MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Locate_Between_Measures MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Locate_Between_Measures MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Locate_Between_Measures(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Locate_Between_Measures MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_M PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_M PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_M LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_M LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_M PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_M PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_M PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_M PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_M LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_M LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_M PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_M PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_M PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_M PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_M LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_M LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_M PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_M PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_M GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_M GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_M CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_M CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_M CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_M CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_M MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_M MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_M MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_M MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_M MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_M MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_M MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_M MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_M MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_M MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_M MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_M MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_M MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_M MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_M MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_M MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_M MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_M(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_M MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_MLineFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_MLineFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MLineFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MLineFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_MLineFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_MLineFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_MLineFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_MLineFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MLineFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_MLineFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MLineFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_MLineFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_MLineFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MLineFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MLineFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MLineFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MLineFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MLineFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_MLineFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_MLineFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MLineFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_MLineFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_MLineFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MLineFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MLineFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_MLineFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_MLineFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_MLineFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_MLineFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MLineFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_MLineFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MLineFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_MLineFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_MLineFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MLineFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MLineFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MLineFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MLineFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MLineFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_MLineFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_MLineFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MLineFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MLineFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MLineFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_MPointFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_MPointFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MPointFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MPointFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_MPointFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_MPointFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_MPointFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_MPointFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MPointFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_MPointFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MPointFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_MPointFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_MPointFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MPointFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MPointFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MPointFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MPointFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MPointFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_MPointFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_MPointFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MPointFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_MPointFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_MPointFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MPointFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MPointFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_MPointFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_MPointFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_MPointFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_MPointFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MPointFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_MPointFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MPointFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_MPointFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_MPointFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MPointFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MPointFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MPointFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MPointFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MPointFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_MPointFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_MPointFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MPointFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPointFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_MPolyFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_MPolyFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MPolyFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MPolyFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_MPolyFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_MPolyFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_MPolyFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_MPolyFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MPolyFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_MPolyFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MPolyFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_MPolyFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_MPolyFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MPolyFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MPolyFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MPolyFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MPolyFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MPolyFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_MPolyFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_MPolyFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MPolyFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_MPolyFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_MPolyFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MPolyFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MPolyFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_MPolyFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_MPolyFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_MPolyFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_MPolyFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MPolyFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_MPolyFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MPolyFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_MPolyFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_MPolyFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MPolyFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MPolyFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MPolyFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MPolyFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MPolyFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_MPolyFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_MPolyFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MPolyFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MPolyFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MPolyFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing PointSet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): End Testing POINT against other types';
		
SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing LineSet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): End Testing LINESTRING against other types';
		
SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing PolySet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): End Testing POLYGON against other types';
		
SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): End Testing POINTM against other types';
		
SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): End Testing LINESTRINGM against other types';
		
SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): End Testing POLYGONM against other types';
		
SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): End Testing POINT against other types';
		
SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): End Testing LINESTRING against other types';
		
SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): End Testing POLYGON against other types';
		
SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): End Testing MULTIPOINT against other types';
		
SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): End Testing POLYGON against other types';
		
SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): End Testing MULTIPOINT against other types';
		
SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_MakeBox2D PointSet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolySet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D PointMSet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox2D LineMSet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D PolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox2D PointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox2D LineSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D PolygonSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D GCSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox2D CurvePolySet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D CircularStringSet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineSet3D(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolySet3D(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox2D MultiPointMSet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox2D MultiLineMSet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox2D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox2D(pointLowLeft, pointUpRight)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox2D MultiPolygonMSet(pointLowLeft, pointUpRight): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): End Testing POINT against other types';
		
SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): End Testing LINESTRING against other types';
		
SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): End Testing POLYGON against other types';
		
SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): End Testing POINTM against other types';
		
SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): End Testing LINESTRINGM against other types';
		
SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): End Testing POLYGONM against other types';
		
SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): End Testing POINT against other types';
		
SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): End Testing LINESTRING against other types';
		
SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): End Testing POLYGON against other types';
		
SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): End Testing MULTIPOINT against other types';
		
SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): End Testing POLYGON against other types';
		
SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): End Testing MULTIPOINT against other types';
		
SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_MakeBox3D PointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D PointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_MakeBox3D LineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D PolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeBox3D PointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakeBox3D LineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D PolygonSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D GCSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeBox3D CurvePolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D CircularStringSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineSet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolySet3D(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeBox3D MultiPointMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeBox3D MultiLineMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_MakeBox3D(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeBox3D(point3DLowLeftBottom, point3DUpRightTop)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeBox3D MultiPolygonMSet(point3DLowLeftBottom, point3DUpRightTop): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_MakeLine PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MakeLine MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing PointSet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine PointSet(point1, point2): End Testing POINT against other types';
		
SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing LineSet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine LineSet(point1, point2): End Testing LINESTRING against other types';
		
SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing PolySet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine PolySet(point1, point2): End Testing POLYGON against other types';
		
SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine PointMSet(point1, point2): End Testing POINTM against other types';
		
SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine LineMSet(point1, point2): End Testing LINESTRINGM against other types';
		
SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine PolygonMSet(point1, point2): End Testing POLYGONM against other types';
		
SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine PointSet3D(point1, point2): End Testing POINT against other types';
		
SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine LineSet3D(point1, point2): End Testing LINESTRING against other types';
		
SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine PolygonSet3D(point1, point2): End Testing POLYGON against other types';
		
SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine GCSet3D(point1, point2): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine CurvePolySet(point1, point2): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine CircularStringSet(point1, point2): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine MultiPointSet(point1, point2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine MultiLineSet(point1, point2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine MultiPolySet(point1, point2): End Testing POLYGON against other types';
		
SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine MultiPointMSet(point1, point2): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine MultiLineMSet(point1, point2): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_MakeLine PointSet(point1, point2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet(point1, point2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolySet(point1, point2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine PointMSet(point1, point2): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_MakeLine LineMSet(point1, point2): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine PolygonMSet(point1, point2): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakeLine PointSet3D(point1, point2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakeLine LineSet3D(point1, point2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakeLine PolygonSet3D(point1, point2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine GCSet3D(point1, point2): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakeLine CurvePolySet(point1, point2): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakeLine CircularStringSet(point1, point2): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet(point1, point2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet(point1, point2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet(point1, point2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointSet3D(point1, point2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakeLine MultiLineSet3D(point1, point2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakeLine MultiPolySet3D(point1, point2): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakeLine MultiPointMSet(point1, point2): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakeLine MultiLineMSet(point1, point2): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakeLine(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakeLine(point1, point2)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakeLine MultiPolygonMSet(point1, point2): End Testing MULTIPOLYGONM against other types';
		SELECT  'Starting ST_MakePoint(x, y)';BEGIN; 
SELECT  ST_MakePoint(0.5, 0.5);
COMMIT;
SELECT  'Ending ST_MakePoint(x, y)';
	SELECT  'Starting ST_MakePoint(x, y, z)';BEGIN; 
SELECT  ST_MakePoint(0.5, 0.5, 0.5);
COMMIT;
SELECT  'Ending ST_MakePoint(x, y, z)';
	SELECT  'Starting ST_MakePoint(x, y, z, m)';BEGIN; 
SELECT  ST_MakePoint(0.5, 0.5, 0.5, 0.5);
COMMIT;
SELECT  'Ending ST_MakePoint(x, y, z, m)';
	SELECT  'Starting ST_MakePointM(x, y, m)';BEGIN; 
SELECT  ST_MakePointM(0.5, 0.5, 0.5);
COMMIT;
SELECT  'Ending ST_MakePointM(x, y, m)';
	
	SELECT 'ST_MakePolygon PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MakePolygon MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing PointSet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): End Testing POINT against other types';
		
SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing LineSet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): End Testing LINESTRING against other types';
		
SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing PolySet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): End Testing POLYGON against other types';
		
SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): End Testing POINTM against other types';
		
SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): End Testing LINESTRINGM against other types';
		
SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): End Testing POLYGONM against other types';
		
SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): End Testing POINT against other types';
		
SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): End Testing LINESTRING against other types';
		
SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): End Testing POLYGON against other types';
		
SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): End Testing MULTIPOINT against other types';
		
SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): End Testing POLYGON against other types';
		
SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): End Testing MULTIPOINT against other types';
		
SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_MakePolygon PointSet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolySet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon PointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_MakePolygon LineMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon PolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_MakePolygon PointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_MakePolygon LineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_MakePolygon PolygonSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon GCSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MakePolygon CurvePolySet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon CircularStringSet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_MakePolygon MultiLineSet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_MakePolygon MultiPolySet3D(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_MakePolygon MultiPointMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_MakePolygon MultiLineMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MakePolygon(foo1.the_geom,  
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_MakePolygon(outerlinestring, interiorlinestrings)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_MakePolygon MultiPolygonMSet(outerlinestring, interiorlinestrings): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance PointSet(g1, g2): End Testing POINT against other types';
		
SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance LineSet(g1, g2): End Testing LINESTRING against other types';
		
SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance PolySet(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance PointMSet(g1, g2): End Testing POINTM against other types';
		
SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance LineMSet(g1, g2): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance PolygonMSet(g1, g2): End Testing POLYGONM against other types';
		
SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance PointSet3D(g1, g2): End Testing POINT against other types';
		
SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance LineSet3D(g1, g2): End Testing LINESTRING against other types';
		
SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance GCSet3D(g1, g2): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance CurvePolySet(g1, g2): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance CircularStringSet(g1, g2): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance MultiPointSet(g1, g2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance MultiLineSet(g1, g2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance MultiPolySet(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Max_Distance PointSet(g1, g2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet(g1, g2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolySet(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance PointMSet(g1, g2): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Max_Distance LineMSet(g1, g2): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance PolygonMSet(g1, g2): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Max_Distance PointSet3D(g1, g2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Max_Distance LineSet3D(g1, g2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Max_Distance PolygonSet3D(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance GCSet3D(g1, g2): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Max_Distance CurvePolySet(g1, g2): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance CircularStringSet(g1, g2): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointSet3D(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Max_Distance MultiLineSet3D(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Max_Distance MultiPolySet3D(g1, g2): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Max_Distance MultiPointMSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Max_Distance MultiLineMSet(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Max_Distance(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Max_Distance(g1, g2)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Max_Distance MultiPolygonMSet(g1, g2): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_MemUnion PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_MemUnion LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MemUnion PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MemUnion PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_MemUnion LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_MemUnion PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_MemUnion PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_MemUnion LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MemUnion PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_MemUnion GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MemUnion CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_MemUnion CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_MemUnion MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MemUnion MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MemUnion MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MemUnion MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MemUnion MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MemUnion MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_MemUnion MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_MemUnion MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MemUnion MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MemUnion(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MemUnion MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Mem_Size PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Mem_Size LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Mem_Size PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Mem_Size PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Mem_Size LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Mem_Size PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Mem_Size PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Mem_Size LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Mem_Size PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Mem_Size GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Mem_Size CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Mem_Size CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Mem_Size MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Mem_Size MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Mem_Size MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Mem_Size MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Mem_Size MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Mem_Size MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Mem_Size MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Mem_Size MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Mem_Size MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Mem_Size(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Mem_Size MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_MinimumBoundingCircle PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_MinimumBoundingCircle LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MinimumBoundingCircle PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MinimumBoundingCircle PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_MinimumBoundingCircle LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_MinimumBoundingCircle PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_MinimumBoundingCircle PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_MinimumBoundingCircle LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MinimumBoundingCircle PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_MinimumBoundingCircle GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MinimumBoundingCircle CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_MinimumBoundingCircle CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_MinimumBoundingCircle PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_MinimumBoundingCircle LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MinimumBoundingCircle PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MinimumBoundingCircle PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_MinimumBoundingCircle LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_MinimumBoundingCircle PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_MinimumBoundingCircle PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_MinimumBoundingCircle LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_MinimumBoundingCircle PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_MinimumBoundingCircle GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_MinimumBoundingCircle CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_MinimumBoundingCircle CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_MinimumBoundingCircle MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_MinimumBoundingCircle(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_MinimumBoundingCircle MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Multi PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Multi LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Multi LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Multi PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Multi PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Multi LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Multi LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Multi PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Multi PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Multi LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Multi PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Multi GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Multi CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Multi CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Multi MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Multi MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Multi MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Multi MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Multi MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Multi MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Multi MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Multi MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Multi MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Multi(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Multi MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_NDims PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_NDims LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NDims LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NDims PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NDims PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_NDims LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NDims LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_NDims PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_NDims PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_NDims LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NDims PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_NDims GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_NDims CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_NDims CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_NDims MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NDims MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NDims MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NDims MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NDims MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NDims MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_NDims MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_NDims MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_NDims MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_NDims(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NDims MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_NPoints PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_NPoints LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NPoints PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NPoints PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_NPoints LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_NPoints PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_NPoints PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_NPoints LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NPoints PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_NPoints GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_NPoints CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_NPoints CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_NPoints MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NPoints MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NPoints MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NPoints MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NPoints MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NPoints MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_NPoints MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_NPoints MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_NPoints MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_NPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NPoints MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_NRings PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_NRings LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NRings LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NRings PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NRings PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_NRings LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NRings LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_NRings PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_NRings PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_NRings LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NRings PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_NRings GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_NRings CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_NRings CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_NRings MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NRings MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NRings MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NRings MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NRings MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NRings MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_NRings MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_NRings MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_NRings MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_NRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NRings MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_NumGeometries PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_NumGeometries LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NumGeometries PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NumGeometries PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_NumGeometries LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_NumGeometries PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_NumGeometries PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_NumGeometries LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NumGeometries PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_NumGeometries GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_NumGeometries CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_NumGeometries CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_NumGeometries MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NumGeometries MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NumGeometries MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NumGeometries MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NumGeometries MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NumGeometries MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_NumGeometries MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_NumGeometries MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_NumGeometries MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_NumGeometries(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumGeometries MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_NumInteriorRing PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_NumInteriorRing LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NumInteriorRing PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NumInteriorRing PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_NumInteriorRing LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_NumInteriorRing PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_NumInteriorRing PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_NumInteriorRing LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NumInteriorRing PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_NumInteriorRing GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_NumInteriorRing CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_NumInteriorRing CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_NumInteriorRing MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NumInteriorRing MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NumInteriorRing MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NumInteriorRing MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NumInteriorRing MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NumInteriorRing MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_NumInteriorRing MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_NumInteriorRing MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_NumInteriorRing MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_NumInteriorRing(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRing MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_NumInteriorRings PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_NumInteriorRings LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NumInteriorRings PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NumInteriorRings PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_NumInteriorRings LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_NumInteriorRings PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_NumInteriorRings PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_NumInteriorRings LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NumInteriorRings PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_NumInteriorRings GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_NumInteriorRings CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_NumInteriorRings CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_NumInteriorRings MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NumInteriorRings MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NumInteriorRings MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NumInteriorRings MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NumInteriorRings MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NumInteriorRings MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_NumInteriorRings MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_NumInteriorRings MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_NumInteriorRings MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_NumInteriorRings(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumInteriorRings MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_NumPoints PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_NumPoints LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NumPoints PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NumPoints PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_NumPoints LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_NumPoints PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_NumPoints PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_NumPoints LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_NumPoints PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_NumPoints GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_NumPoints CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_NumPoints CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_NumPoints MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NumPoints MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NumPoints MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_NumPoints MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_NumPoints MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_NumPoints MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_NumPoints MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_NumPoints MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_NumPoints MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_NumPoints(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_NumPoints MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing PointSet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals PointSet(A, B): End Testing POINT against other types';
		
SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing LineSet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals LineSet(A, B): End Testing LINESTRING against other types';
		
SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing PolySet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals PolySet(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals PointMSet(A, B): End Testing POINTM against other types';
		
SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals LineMSet(A, B): End Testing LINESTRINGM against other types';
		
SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals PolygonMSet(A, B): End Testing POLYGONM against other types';
		
SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals PointSet3D(A, B): End Testing POINT against other types';
		
SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals LineSet3D(A, B): End Testing LINESTRING against other types';
		
SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals PolygonSet3D(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals GCSet3D(A, B): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals CurvePolySet(A, B): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals CircularStringSet(A, B): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals MultiPointSet(A, B): End Testing MULTIPOINT against other types';
		
SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals MultiLineSet(A, B): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals MultiPolySet(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): End Testing MULTIPOINT against other types';
		
SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals MultiPointMSet(A, B): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals MultiLineMSet(A, B): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_OrderingEquals PointSet(A, B): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet(A, B): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolySet(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals PointMSet(A, B): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_OrderingEquals LineMSet(A, B): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals PolygonMSet(A, B): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_OrderingEquals PointSet3D(A, B): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_OrderingEquals LineSet3D(A, B): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals PolygonSet3D(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals GCSet3D(A, B): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_OrderingEquals CurvePolySet(A, B): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals CircularStringSet(A, B): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet(A, B): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet(A, B): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointSet3D(A, B): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineSet3D(A, B): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolySet3D(A, B): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_OrderingEquals MultiPointMSet(A, B): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_OrderingEquals MultiLineMSet(A, B): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_OrderingEquals(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_OrderingEquals(A, B)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_OrderingEquals MultiPolygonMSet(A, B): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_Overlaps PointSet(A, B): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps PointSet(A, B): End Testing POINT against other types';
		
SELECT 'ST_Overlaps LineSet(A, B): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps LineSet(A, B): End Testing LINESTRING against other types';
		
SELECT 'ST_Overlaps PolySet(A, B): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps PolySet(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Overlaps PointMSet(A, B): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps PointMSet(A, B): End Testing POINTM against other types';
		
SELECT 'ST_Overlaps LineMSet(A, B): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps LineMSet(A, B): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps PolygonMSet(A, B): End Testing POLYGONM against other types';
		
SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps PointSet3D(A, B): End Testing POINT against other types';
		
SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps LineSet3D(A, B): End Testing LINESTRING against other types';
		
SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps PolygonSet3D(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps GCSet3D(A, B): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps CurvePolySet(A, B): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps CircularStringSet(A, B): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps MultiPointSet(A, B): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps MultiLineSet(A, B): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps MultiPolySet(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps MultiPointSet3D(A, B): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps MultiLineSet3D(A, B): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps MultiPolySet3D(A, B): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps MultiPointMSet(A, B): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps MultiLineMSet(A, B): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Overlaps PointSet(A, B): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet(A, B): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolySet(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps PointMSet(A, B): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Overlaps LineMSet(A, B): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps PolygonMSet(A, B): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Overlaps PointSet3D(A, B): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Overlaps LineSet3D(A, B): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Overlaps PolygonSet3D(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps GCSet3D(A, B): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Overlaps CurvePolySet(A, B): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Overlaps CircularStringSet(A, B): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet(A, B): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet(A, B): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointSet3D(A, B): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Overlaps MultiLineSet3D(A, B): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Overlaps MultiPolySet3D(A, B): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Overlaps MultiPointMSet(A, B): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Overlaps MultiLineMSet(A, B): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Overlaps MultiPolygonMSet(A, B): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Overlaps(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Overlaps(A, B)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Overlaps MultiPolygonMSet(A, B): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_Perimeter PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Perimeter LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Perimeter PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Perimeter PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Perimeter LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Perimeter PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Perimeter PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Perimeter LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Perimeter PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Perimeter GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Perimeter CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Perimeter CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Perimeter MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Perimeter MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Perimeter MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Perimeter MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Perimeter MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Perimeter MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Perimeter MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Perimeter MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Perimeter MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Perimeter(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Perimeter2D PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Perimeter2D LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Perimeter2D PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Perimeter2D PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Perimeter2D LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Perimeter2D PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Perimeter2D PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Perimeter2D LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Perimeter2D PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Perimeter2D GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Perimeter2D CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Perimeter2D CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Perimeter2D MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Perimeter2D MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Perimeter2D MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Perimeter2D MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Perimeter2D MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Perimeter2D MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Perimeter2D MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Perimeter2D MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Perimeter2D MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Perimeter2D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter2D MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Perimeter3D PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Perimeter3D LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Perimeter3D PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Perimeter3D PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Perimeter3D LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Perimeter3D PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Perimeter3D PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Perimeter3D LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Perimeter3D PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Perimeter3D GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Perimeter3D CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Perimeter3D CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Perimeter3D MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Perimeter3D MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Perimeter3D MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Perimeter3D MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Perimeter3D MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Perimeter3D MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Perimeter3D MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Perimeter3D MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Perimeter3D MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Perimeter3D(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Perimeter3D MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		SELECT  'Starting ST_Point(x_lon, y_lat)';BEGIN; 
SELECT  ST_Point(0.5, 0.5);
COMMIT;
SELECT  'Ending ST_Point(x_lon, y_lat)';
	
	SELECT 'ST_PointFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_PointFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_PointFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_PointFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_PointFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_PointFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_PointFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_PointFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_PointFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_PointFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_PointFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_PointFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_PointFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_PointFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_PointFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_PointFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_PointFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_PointFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_PointFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_PointFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_PointFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_PointFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_PointFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_PointFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_PointFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_PointFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_PointFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_PointFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_PointFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_PointFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_PointFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_PointFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_PointFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_PointFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_PointFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_PointFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_PointFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_PointFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_PointFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_PointFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_PointFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_PointFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_PointN PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_PointN LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_PointN LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_PointN PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_PointN PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_PointN LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_PointN LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_PointN PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_PointN PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_PointN LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_PointN PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_PointN GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_PointN CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_PointN CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_PointN MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_PointN MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_PointN MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_PointN MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_PointN MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_PointN MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_PointN MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_PointN MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_PointN MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointN(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointN MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_PointOnSurface PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_PointOnSurface LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_PointOnSurface PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_PointOnSurface PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_PointOnSurface LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_PointOnSurface PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_PointOnSurface PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_PointOnSurface LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_PointOnSurface PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_PointOnSurface GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_PointOnSurface CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_PointOnSurface CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_PointOnSurface MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_PointOnSurface MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_PointOnSurface MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_PointOnSurface MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_PointOnSurface MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_PointOnSurface MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_PointOnSurface MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_PointOnSurface MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_PointOnSurface MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PointOnSurface(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PointOnSurface MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Point_Inside_Circle PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Point_Inside_Circle LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Point_Inside_Circle PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Point_Inside_Circle PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Point_Inside_Circle LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Point_Inside_Circle PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Point_Inside_Circle PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Point_Inside_Circle LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Point_Inside_Circle PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Point_Inside_Circle GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Point_Inside_Circle CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Point_Inside_Circle CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Point_Inside_Circle MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Point_Inside_Circle MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Point_Inside_Circle MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Point_Inside_Circle MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Point_Inside_Circle MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Point_Inside_Circle MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Point_Inside_Circle MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Point_Inside_Circle MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Point_Inside_Circle MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Point_Inside_Circle(foo1.the_geom, 0.5, 0.5, 0.5)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Point_Inside_Circle MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Polygon PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Polygon LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Polygon PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Polygon PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Polygon LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Polygon PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Polygon PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Polygon LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Polygon PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Polygon GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Polygon CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Polygon CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Polygon MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Polygon MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Polygon MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Polygon MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Polygon MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Polygon MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Polygon MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Polygon MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Polygon MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygon(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygon MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_PolygonFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_PolygonFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_PolygonFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_PolygonFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_PolygonFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_PolygonFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_PolygonFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_PolygonFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_PolygonFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_PolygonFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_PolygonFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_PolygonFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_PolygonFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_PolygonFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_PolygonFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_PolygonFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_PolygonFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_PolygonFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_PolygonFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_PolygonFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_PolygonFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_PolygonFromText PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_PolygonFromText LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_PolygonFromText PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_PolygonFromText PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_PolygonFromText LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_PolygonFromText PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_PolygonFromText PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_PolygonFromText LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_PolygonFromText PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_PolygonFromText GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_PolygonFromText CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_PolygonFromText CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_PolygonFromText MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_PolygonFromText MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_PolygonFromText MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_PolygonFromText MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_PolygonFromText MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_PolygonFromText MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_PolygonFromText MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_PolygonFromText MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_PolygonFromText MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_PolygonFromText(ST_AsText(foo1.the_geom), 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_PolygonFromText MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Polygonize PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Polygonize LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Polygonize PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Polygonize PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Polygonize LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Polygonize PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Polygonize PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Polygonize LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Polygonize PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Polygonize GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Polygonize CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Polygonize CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Polygonize MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Polygonize MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Polygonize MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Polygonize MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Polygonize MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Polygonize MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Polygonize MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Polygonize MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Polygonize MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Polygonize(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Polygonize MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PointSet(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate LineSet(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PointMSet(geomA, geomB): End Testing POINTM against other types';
		
SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate LineMSet(geomA, geomB): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PolygonMSet(geomA, geomB): End Testing POLYGONM against other types';
		
SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PointSet3D(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate LineSet3D(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PolygonSet3D(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate GCSet3D(geomA, geomB): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate CurvePolySet(geomA, geomB): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate CircularStringSet(geomA, geomB): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiPointSet(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiLineSet(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiPolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiPointMSet(geomA, geomB): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiLineMSet(geomA, geomB): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): End Testing POINT against other types';
		
SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): End Testing LINESTRING against other types';
		
SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): End Testing POLYGON against other types';
		
SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): End Testing POINTM against other types';
		
SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): End Testing POLYGONM against other types';
		
SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): End Testing POINT against other types';
		
SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): End Testing LINESTRING against other types';
		
SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): End Testing POLYGON against other types';
		
SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): End Testing POLYGON against other types';
		
SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Relate PointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate PointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Relate LineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Relate PolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Relate PointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Relate LineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Relate PolygonSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate GCSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Relate CurvePolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Relate CircularStringSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Relate MultiPointSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Relate MultiLineSet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Relate MultiPolySet3D(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Relate MultiPointMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Relate MultiLineMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Relate(foo1.the_geom, foo2.the_geom, 'FF1FF0102')
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Relate(geomA, geomB, intersectionPatternMatrix)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Relate MultiPolygonMSet(geomA, geomB, intersectionPatternMatrix): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_RemovePoint PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_RemovePoint LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_RemovePoint PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_RemovePoint PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_RemovePoint LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_RemovePoint PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_RemovePoint PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_RemovePoint LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_RemovePoint PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_RemovePoint GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_RemovePoint CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_RemovePoint CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_RemovePoint MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_RemovePoint MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_RemovePoint MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_RemovePoint MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_RemovePoint MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_RemovePoint MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_RemovePoint MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_RemovePoint MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_RemovePoint MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RemovePoint(foo1.the_geom, 3))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RemovePoint MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Reverse PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Reverse LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Reverse PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Reverse PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Reverse LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Reverse PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Reverse PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Reverse LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Reverse PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Reverse GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Reverse CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Reverse CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Reverse MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Reverse MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Reverse MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Reverse MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Reverse MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Reverse MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Reverse MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Reverse MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Reverse MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Reverse(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Reverse MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Rotate PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Rotate LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Rotate PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Rotate PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Rotate LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Rotate PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Rotate PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Rotate LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Rotate PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Rotate GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Rotate CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Rotate CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Rotate MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Rotate MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Rotate MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Rotate MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Rotate MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Rotate MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Rotate MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Rotate MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Rotate MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Rotate(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Rotate MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_RotateX PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_RotateX LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_RotateX PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_RotateX PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_RotateX LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_RotateX PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_RotateX PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_RotateX LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_RotateX PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_RotateX GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_RotateX CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_RotateX CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_RotateX MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_RotateX MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_RotateX MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_RotateX MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_RotateX MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_RotateX MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_RotateX MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_RotateX MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_RotateX MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateX(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateX MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_RotateY PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_RotateY LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_RotateY PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_RotateY PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_RotateY LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_RotateY PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_RotateY PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_RotateY LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_RotateY PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_RotateY GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_RotateY CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_RotateY CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_RotateY MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_RotateY MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_RotateY MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_RotateY MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_RotateY MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_RotateY MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_RotateY MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_RotateY MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_RotateY MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateY(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateY MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_RotateZ PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_RotateZ LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_RotateZ PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_RotateZ PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_RotateZ LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_RotateZ PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_RotateZ PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_RotateZ LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_RotateZ PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_RotateZ GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_RotateZ CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_RotateZ CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_RotateZ MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_RotateZ MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_RotateZ MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_RotateZ MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_RotateZ MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_RotateZ MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_RotateZ MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_RotateZ MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_RotateZ MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_RotateZ(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_RotateZ MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_SRID PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_SRID LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_SRID LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_SRID PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_SRID PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_SRID LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_SRID LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_SRID PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_SRID PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_SRID LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_SRID PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_SRID GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SRID CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_SRID CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_SRID MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_SRID MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_SRID MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_SRID MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_SRID MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_SRID MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_SRID MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_SRID MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SRID MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_SRID(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SRID MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Scale PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Scale LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Scale LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Scale PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Scale PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Scale LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Scale LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Scale PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Scale PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Scale LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Scale PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Scale GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Scale CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Scale CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Scale MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Scale MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Scale MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Scale MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Scale MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Scale MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Scale MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Scale MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Scale MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Scale PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Scale LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Scale LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Scale PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Scale PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Scale LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Scale LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Scale PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Scale PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Scale LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Scale PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Scale GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Scale CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Scale CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Scale MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Scale MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Scale MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Scale MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Scale MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Scale MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Scale MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Scale MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Scale MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Scale(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Scale MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Segmentize PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Segmentize LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Segmentize PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Segmentize PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Segmentize LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Segmentize PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Segmentize PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Segmentize LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Segmentize PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Segmentize GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Segmentize CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Segmentize CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Segmentize MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Segmentize MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Segmentize MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Segmentize MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Segmentize MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Segmentize MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Segmentize MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Segmentize MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Segmentize MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Segmentize(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Segmentize MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing PointSet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): End Testing POINT against other types';
		
SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing LineSet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): End Testing LINESTRING against other types';
		
SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing PolySet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): End Testing POLYGON against other types';
		
SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): End Testing POINTM against other types';
		
SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): End Testing LINESTRINGM against other types';
		
SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): End Testing POLYGONM against other types';
		
SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): End Testing POINT against other types';
		
SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): End Testing LINESTRING against other types';
		
SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): End Testing POLYGON against other types';
		
SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): End Testing MULTIPOINT against other types';
		
SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): End Testing POLYGON against other types';
		
SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): End Testing MULTIPOINT against other types';
		
SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_SetPoint PointSet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolySet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint PointMSet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_SetPoint LineMSet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint PolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_SetPoint PointSet3D(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_SetPoint LineSet3D(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_SetPoint PolygonSet3D(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint GCSet3D(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetPoint CurvePolySet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetPoint CircularStringSet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointSet3D(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SetPoint MultiLineSet3D(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SetPoint MultiPolySet3D(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetPoint MultiPointMSet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SetPoint MultiLineMSet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetPoint(foo1.the_geom, 1, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SetPoint(linestring, zerobasedposition, point)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SetPoint MultiPolygonMSet(linestring, zerobasedposition, point): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_SetSRID PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_SetSRID LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_SetSRID PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_SetSRID PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_SetSRID LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_SetSRID PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_SetSRID PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_SetSRID LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_SetSRID PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_SetSRID GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SetSRID CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_SetSRID CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_SetSRID MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_SetSRID MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_SetSRID MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_SetSRID MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_SetSRID MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_SetSRID MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_SetSRID MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_SetSRID MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SetSRID MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SetSRID(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SetSRID MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Shift_Longitude PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Shift_Longitude LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Shift_Longitude PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Shift_Longitude PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Shift_Longitude LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Shift_Longitude PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Shift_Longitude PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Shift_Longitude LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Shift_Longitude PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Shift_Longitude GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Shift_Longitude CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Shift_Longitude CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Shift_Longitude MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Shift_Longitude MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Shift_Longitude MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Shift_Longitude MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Shift_Longitude MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Shift_Longitude MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Shift_Longitude MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Shift_Longitude MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Shift_Longitude MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Shift_Longitude(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Shift_Longitude MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Simplify PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Simplify LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Simplify PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Simplify PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Simplify LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Simplify PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Simplify PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Simplify LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Simplify PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Simplify GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Simplify CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Simplify CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Simplify MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Simplify MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Simplify MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Simplify MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Simplify MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Simplify MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Simplify MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Simplify MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Simplify MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Simplify(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Simplify MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SimplifyPreserveTopology MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SimplifyPreserveTopology(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SimplifyPreserveTopology MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_SnapToGrid MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing POINT against other types';
		
SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing LINESTRING against other types';
		
SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing POLYGON against other types';
		
SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing POINTM against other types';
		
SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing LINESTRINGM against other types';
		
SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing POLYGONM against other types';
		
SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing POINT against other types';
		
SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing LINESTRING against other types';
		
SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing POLYGON against other types';
		
SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing MULTIPOINT against other types';
		
SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing POLYGON against other types';
		
SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing MULTIPOINT against other types';
		
SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_SnapToGrid PointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid PointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_SnapToGrid LineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid PolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_SnapToGrid PointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_SnapToGrid LineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid PolygonSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid GCSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SnapToGrid CurvePolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid CircularStringSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineSet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolySet3D(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SnapToGrid MultiPointMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SnapToGrid MultiLineMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SnapToGrid(foo1.the_geom, foo2.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SnapToGrid(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SnapToGrid MultiPolygonMSet(geomA, pointOrigin, sizeX, sizeY, sizeZ, sizeM): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_StartPoint PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_StartPoint LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_StartPoint PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_StartPoint PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_StartPoint LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_StartPoint PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_StartPoint PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_StartPoint LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_StartPoint PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_StartPoint GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_StartPoint CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_StartPoint CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_StartPoint MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_StartPoint MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_StartPoint MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_StartPoint MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_StartPoint MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_StartPoint MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_StartPoint MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_StartPoint MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_StartPoint MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_StartPoint(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_StartPoint MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Summary PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Summary LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Summary LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Summary PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Summary PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Summary LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Summary LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Summary PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Summary PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Summary LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Summary PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Summary GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Summary CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Summary CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Summary MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Summary MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Summary MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Summary MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Summary MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Summary MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Summary MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Summary MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Summary MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Summary(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Summary MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing PointSet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference PointSet(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing LineSet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference LineSet(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing PolySet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference PolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference PointMSet(geomA, geomB): End Testing POINTM against other types';
		
SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference LineMSet(geomA, geomB): End Testing LINESTRINGM against other types';
		
SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): End Testing POLYGONM against other types';
		
SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference PointSet3D(geomA, geomB): End Testing POINT against other types';
		
SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference LineSet3D(geomA, geomB): End Testing LINESTRING against other types';
		
SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference GCSet3D(geomA, geomB): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): End Testing POLYGON against other types';
		
SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): End Testing MULTIPOINT against other types';
		
SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_SymDifference PointSet(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference PointMSet(geomA, geomB): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_SymDifference LineMSet(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference PolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_SymDifference PointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_SymDifference LineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_SymDifference PolygonSet3D(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference GCSet3D(geomA, geomB): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_SymDifference CurvePolySet(geomA, geomB): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_SymDifference CircularStringSet(geomA, geomB): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet(geomA, geomB): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_SymDifference MultiLineSet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_SymDifference MultiPolySet3D(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_SymDifference MultiPointMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_SymDifference MultiLineMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_SymDifference(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_SymDifference(geomA, geomB)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_SymDifference MultiPolygonMSet(geomA, geomB): End Testing MULTIPOLYGONM against other types';
		
SELECT 'ST_Touches PointSet(g1, g2): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches PointSet(g1, g2): End Testing POINT against other types';
		
SELECT 'ST_Touches LineSet(g1, g2): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches LineSet(g1, g2): End Testing LINESTRING against other types';
		
SELECT 'ST_Touches PolySet(g1, g2): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches PolySet(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Touches PointMSet(g1, g2): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches PointMSet(g1, g2): End Testing POINTM against other types';
		
SELECT 'ST_Touches LineMSet(g1, g2): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches LineMSet(g1, g2): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches PolygonMSet(g1, g2): End Testing POLYGONM against other types';
		
SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches PointSet3D(g1, g2): End Testing POINT against other types';
		
SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches LineSet3D(g1, g2): End Testing LINESTRING against other types';
		
SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches PolygonSet3D(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches GCSet3D(g1, g2): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches CurvePolySet(g1, g2): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches CircularStringSet(g1, g2): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches MultiPointSet(g1, g2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches MultiLineSet(g1, g2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches MultiPolySet(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches MultiPointSet3D(g1, g2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches MultiLineSet3D(g1, g2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches MultiPolySet3D(g1, g2): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches MultiPointMSet(g1, g2): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches MultiLineMSet(g1, g2): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Touches PointSet(g1, g2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet(g1, g2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolySet(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches PointMSet(g1, g2): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Touches LineMSet(g1, g2): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Touches PolygonMSet(g1, g2): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Touches PointSet3D(g1, g2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Touches LineSet3D(g1, g2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Touches PolygonSet3D(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches GCSet3D(g1, g2): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Touches CurvePolySet(g1, g2): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Touches CircularStringSet(g1, g2): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Touches MultiPointSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointSet3D(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Touches MultiLineSet3D(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Touches MultiPolySet3D(g1, g2): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Touches MultiPointMSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Touches MultiLineMSet(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Touches MultiPolygonMSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Touches(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Touches(g1, g2)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Touches MultiPolygonMSet(g1, g2): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_TransScale PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_TransScale LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_TransScale PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_TransScale PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_TransScale LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_TransScale PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_TransScale PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_TransScale LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_TransScale PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_TransScale GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_TransScale CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_TransScale CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_TransScale MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_TransScale MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_TransScale MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_TransScale MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_TransScale MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_TransScale MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_TransScale MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_TransScale MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_TransScale MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_TransScale(foo1.the_geom, 0.5, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_TransScale MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Transform PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Transform LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Transform LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Transform PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Transform PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Transform LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Transform LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Transform PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Transform PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Transform LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Transform PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Transform GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Transform CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Transform CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Transform MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Transform MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Transform MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Transform MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Transform MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Transform MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Transform MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Transform MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Transform MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Transform(foo1.the_geom, 3395))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Transform MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Translate PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Translate LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Translate LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Translate PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Translate PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Translate LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Translate LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Translate PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Translate PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Translate LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Translate PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Translate GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Translate CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Translate CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Translate MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Translate MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Translate MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Translate MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Translate MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Translate MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Translate MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Translate MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Translate MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Translate PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Translate LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Translate LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Translate PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Translate PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Translate LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Translate LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Translate PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Translate PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Translate LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Translate PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Translate GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Translate CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Translate CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Translate MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Translate MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Translate MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Translate MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Translate MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Translate MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Translate MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Translate MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Translate MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Translate(foo1.the_geom, 0.5, 0.5, 0.5))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Translate MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Union PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Union PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Union LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Union LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Union PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Union PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Union LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Union LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Union PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Union PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Union LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Union LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Union PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Union GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Union CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Union CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union PointSet(g1, g2): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union PointSet(g1, g2): End Testing POINT against other types';
		
SELECT 'ST_Union LineSet(g1, g2): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union LineSet(g1, g2): End Testing LINESTRING against other types';
		
SELECT 'ST_Union PolySet(g1, g2): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union PolySet(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Union PointMSet(g1, g2): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union PointMSet(g1, g2): End Testing POINTM against other types';
		
SELECT 'ST_Union LineMSet(g1, g2): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union LineMSet(g1, g2): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union PolygonMSet(g1, g2): End Testing POLYGONM against other types';
		
SELECT 'ST_Union PointSet3D(g1, g2): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union PointSet3D(g1, g2): End Testing POINT against other types';
		
SELECT 'ST_Union LineSet3D(g1, g2): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union LineSet3D(g1, g2): End Testing LINESTRING against other types';
		
SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union PolygonSet3D(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Union GCSet3D(g1, g2): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union GCSet3D(g1, g2): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union CurvePolySet(g1, g2): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union CircularStringSet(g1, g2): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union MultiPointSet(g1, g2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union MultiLineSet(g1, g2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union MultiPolySet(g1, g2): End Testing POLYGON against other types';
		
SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union MultiPointSet3D(g1, g2): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union MultiLineSet3D(g1, g2): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union MultiPolySet3D(g1, g2): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union MultiPointMSet(g1, g2): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union MultiLineMSet(g1, g2): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Union PointSet(g1, g2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet(g1, g2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet(g1, g2): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Union LineMSet(g1, g2): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet(g1, g2): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D(g1, g2): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Union LineSet3D(g1, g2): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D(g1, g2): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet(g1, g2): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet(g1, g2): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet(g1, g2): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D(g1, g2): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet(g1, g2): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet(g1, g2): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union(foo1.the_geom, foo2.the_geom))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Union(g1, g2)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Union MultiPolygonMSet(g1, g2): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_Union PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Union PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Union LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Union LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Union PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Union PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Union PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Union PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Union LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Union LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Union PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Union PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Union PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Union PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Union LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Union LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Union PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Union PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Union GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Union GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Union CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Union CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Union CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Union CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Union MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Union MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Union MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Union MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Union MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Union MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Union MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_Union( 
						ARRAY[foo2.the_geom]
					))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Union MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_WKBToSQL PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_WKBToSQL LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_WKBToSQL PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_WKBToSQL PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_WKBToSQL LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_WKBToSQL PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_WKBToSQL PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_WKBToSQL LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_WKBToSQL PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_WKBToSQL GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_WKBToSQL CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_WKBToSQL CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_WKBToSQL MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_WKBToSQL MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_WKBToSQL MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_WKBToSQL MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_WKBToSQL MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_WKBToSQL MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_WKBToSQL MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_WKBToSQL MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_WKBToSQL MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKBToSQL(ST_AsBinary(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_WKBToSQL MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_WKTToSQL PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_WKTToSQL LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_WKTToSQL PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_WKTToSQL PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_WKTToSQL LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_WKTToSQL PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_WKTToSQL PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_WKTToSQL LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_WKTToSQL PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_WKTToSQL GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_WKTToSQL CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_WKTToSQL CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_WKTToSQL MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_WKTToSQL MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_WKTToSQL MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_WKTToSQL MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_WKTToSQL MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_WKTToSQL MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_WKTToSQL MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_WKTToSQL MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_WKTToSQL MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_AsEWKT(ST_WKTToSQL(ST_AsText(foo1.the_geom)))
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_WKTToSQL MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within PointSet(A, B): Start Testing PointSet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing PointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing PointSet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing PointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing PointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing PointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing PointSet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing PointSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing PointSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing PointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing PointSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing PointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing PointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing PointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing PointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing PointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing PointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing PointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing PointSet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing PointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing PointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing PointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing PointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing PointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing PointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing PointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing PointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing PointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing PointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing PointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing PointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within PointSet(A, B): End Testing POINT against other types';
		
SELECT 'ST_Within LineSet(A, B): Start Testing LineSet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing LineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing LineSet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing LineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing LineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing LineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing LineSet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing LineSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing LineSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing LineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing LineSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing LineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing LineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing LineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing LineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing LineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing LineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing LineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing LineSet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing LineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing LineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing LineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing LineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing LineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing LineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing LineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing LineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing LineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing LineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing LineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing LineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within LineSet(A, B): End Testing LINESTRING against other types';
		
SELECT 'ST_Within PolySet(A, B): Start Testing PolySet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing PolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing PolySet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing PolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing PolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing PolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing PolySet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing PolySet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing PolySet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing PolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing PolySet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing PolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing PolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing PolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing PolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing PolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing PolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing PolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing PolySet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing PolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing PolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing PolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing PolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing PolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing PolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing PolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing PolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing PolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing PolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing PolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing PolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within PolySet(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Within PointMSet(A, B): Start Testing PointMSet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing PointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing PointMSet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing PointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing PointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing PointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing PointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing PointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing PointMSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing PointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing PointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing PointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing PointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing PointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing PointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing PointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing PointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing PointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing PointMSet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing PointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing PointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing PointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing PointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing PointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing PointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing PointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing PointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing PointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing PointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing PointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing PointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within PointMSet(A, B): End Testing POINTM against other types';
		
SELECT 'ST_Within LineMSet(A, B): Start Testing LineMSet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing LineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing LineMSet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing LineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing LineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing LineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing LineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing LineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing LineMSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing LineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing LineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing LineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing LineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing LineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing LineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing LineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing LineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing LineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing LineMSet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing LineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing LineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing LineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing LineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing LineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing LineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing LineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing LineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing LineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing LineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing LineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing LineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within LineMSet(A, B): End Testing LINESTRINGM against other types';
		
SELECT 'ST_Within PolygonMSet(A, B): Start Testing PolygonMSet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing PolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing PolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing PolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing PolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing PolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing PolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing PolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing PolygonMSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing PolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing PolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing PolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing PolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing PolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing PolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing PolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing PolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing PolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing PolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing PolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing PolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing PolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing PolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing PolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing PolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing PolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing PolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing PolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing PolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing PolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing PolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within PolygonMSet(A, B): End Testing POLYGONM against other types';
		
SELECT 'ST_Within PointSet3D(A, B): Start Testing PointSet3D against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing PointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing PointSet3D, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing PointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing PointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing PointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing PointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing PointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing PointSet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing PointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing PointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing PointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing PointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing PointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing PointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing PointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing PointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing PointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing PointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing PointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing PointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing PointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing PointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing PointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing PointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing PointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing PointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing PointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing PointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing PointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing PointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within PointSet3D(A, B): End Testing POINT against other types';
		
SELECT 'ST_Within LineSet3D(A, B): Start Testing LineSet3D against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing LineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing LineSet3D, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing LineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing LineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing LineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing LineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing LineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing LineSet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing LineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing LineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing LineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing LineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing LineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing LineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing LineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing LineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing LineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing LineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing LineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing LineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing LineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing LineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing LineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing LineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing LineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing LineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing LineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing LineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing LineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing LineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within LineSet3D(A, B): End Testing LINESTRING against other types';
		
SELECT 'ST_Within PolygonSet3D(A, B): Start Testing PolygonSet3D against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing PolygonSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing PolygonSet3D, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing PolygonSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing PolygonSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing PolygonSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing PolygonSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing PolygonSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing PolygonSet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing PolygonSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing PolygonSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing PolygonSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing PolygonSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing PolygonSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing PolygonSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing PolygonSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing PolygonSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing PolygonSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing PolygonSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing PolygonSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing PolygonSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing PolygonSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing PolygonSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing PolygonSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing PolygonSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing PolygonSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing PolygonSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing PolygonSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing PolygonSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing PolygonSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing PolygonSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within PolygonSet3D(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Within GCSet3D(A, B): Start Testing GCSet3D against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing GCSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing GCSet3D, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing GCSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing GCSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing GCSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing GCSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing GCSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing GCSet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing GCSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing GCSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing GCSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing GCSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing GCSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing GCSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing GCSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing GCSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing GCSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing GCSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing GCSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing GCSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing GCSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing GCSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing GCSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing GCSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing GCSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing GCSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing GCSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing GCSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing GCSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing GCSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within GCSet3D(A, B): End Testing GEOMETRYCOLLECTION against other types';
		
SELECT 'ST_Within CurvePolySet(A, B): Start Testing CurvePolySet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing CurvePolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing CurvePolySet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing CurvePolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing CurvePolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing CurvePolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing CurvePolySet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing CurvePolySet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing CurvePolySet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing CurvePolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing CurvePolySet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing CurvePolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing CurvePolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing CurvePolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing CurvePolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing CurvePolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing CurvePolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing CurvePolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing CurvePolySet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing CurvePolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing CurvePolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing CurvePolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing CurvePolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing CurvePolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing CurvePolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing CurvePolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing CurvePolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing CurvePolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing CurvePolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing CurvePolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing CurvePolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within CurvePolySet(A, B): End Testing CURVEPOLYGON against other types';
		
SELECT 'ST_Within CircularStringSet(A, B): Start Testing CircularStringSet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing CircularStringSet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing CircularStringSet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing CircularStringSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing CircularStringSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing CircularStringSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing CircularStringSet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing CircularStringSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing CircularStringSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing CircularStringSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing CircularStringSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing CircularStringSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing CircularStringSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing CircularStringSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing CircularStringSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing CircularStringSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing CircularStringSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing CircularStringSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing CircularStringSet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing CircularStringSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing CircularStringSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing CircularStringSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing CircularStringSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing CircularStringSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing CircularStringSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing CircularStringSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing CircularStringSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing CircularStringSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing CircularStringSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing CircularStringSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing CircularStringSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within CircularStringSet(A, B): End Testing CIRCULARSTRING against other types';
		
SELECT 'ST_Within MultiPointSet(A, B): Start Testing MultiPointSet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing MultiPointSet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing MultiPointSet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing MultiPointSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing MultiPointSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing MultiPointSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing MultiPointSet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing MultiPointSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing MultiPointSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing MultiPointSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing MultiPointSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing MultiPointSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing MultiPointSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing MultiPointSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing MultiPointSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing MultiPointSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing MultiPointSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing MultiPointSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing MultiPointSet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing MultiPointSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing MultiPointSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing MultiPointSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing MultiPointSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing MultiPointSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing MultiPointSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing MultiPointSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing MultiPointSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing MultiPointSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing MultiPointSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing MultiPointSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing MultiPointSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within MultiPointSet(A, B): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Within MultiLineSet(A, B): Start Testing MultiLineSet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing MultiLineSet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing MultiLineSet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing MultiLineSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing MultiLineSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing MultiLineSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing MultiLineSet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing MultiLineSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing MultiLineSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing MultiLineSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing MultiLineSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing MultiLineSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing MultiLineSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing MultiLineSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing MultiLineSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing MultiLineSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing MultiLineSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing MultiLineSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing MultiLineSet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing MultiLineSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing MultiLineSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing MultiLineSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing MultiLineSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing MultiLineSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing MultiLineSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing MultiLineSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing MultiLineSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing MultiLineSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing MultiLineSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing MultiLineSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing MultiLineSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within MultiLineSet(A, B): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Within MultiPolySet(A, B): Start Testing MultiPolySet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing MultiPolySet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing MultiPolySet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing MultiPolySet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing MultiPolySet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing MultiPolySet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing MultiPolySet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing MultiPolySet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing MultiPolySet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing MultiPolySet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing MultiPolySet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing MultiPolySet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing MultiPolySet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing MultiPolySet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing MultiPolySet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing MultiPolySet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing MultiPolySet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing MultiPolySet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing MultiPolySet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing MultiPolySet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing MultiPolySet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing MultiPolySet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing MultiPolySet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing MultiPolySet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing MultiPolySet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing MultiPolySet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing MultiPolySet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing MultiPolySet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing MultiPolySet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing MultiPolySet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing MultiPolySet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within MultiPolySet(A, B): End Testing POLYGON against other types';
		
SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing MultiPointSet3D against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing MultiPointSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing MultiPointSet3D, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing MultiPointSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing MultiPointSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing MultiPointSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing MultiPointSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing MultiPointSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing MultiPointSet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing MultiPointSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing MultiPointSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing MultiPointSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing MultiPointSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing MultiPointSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing MultiPointSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing MultiPointSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing MultiPointSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing MultiPointSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing MultiPointSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing MultiPointSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing MultiPointSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing MultiPointSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing MultiPointSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing MultiPointSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing MultiPointSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing MultiPointSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing MultiPointSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing MultiPointSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing MultiPointSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing MultiPointSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing MultiPointSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within MultiPointSet3D(A, B): End Testing MULTIPOINT against other types';
		
SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing MultiLineSet3D against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing MultiLineSet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing MultiLineSet3D, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing MultiLineSet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing MultiLineSet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing MultiLineSet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing MultiLineSet3D, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing MultiLineSet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing MultiLineSet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing MultiLineSet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing MultiLineSet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing MultiLineSet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing MultiLineSet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing MultiLineSet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing MultiLineSet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing MultiLineSet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing MultiLineSet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing MultiLineSet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing MultiLineSet3D, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing MultiLineSet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing MultiLineSet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing MultiLineSet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing MultiLineSet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing MultiLineSet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing MultiLineSet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing MultiLineSet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing MultiLineSet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing MultiLineSet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing MultiLineSet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing MultiLineSet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing MultiLineSet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within MultiLineSet3D(A, B): End Testing MULTILINESTRING against other types';
		
SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing MultiPolySet3D against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing MultiPolySet3D, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing MultiPolySet3D, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing MultiPolySet3D, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing MultiPolySet3D, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing MultiPolySet3D, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing MultiPolySet3D, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing MultiPolySet3D, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing MultiPolySet3D, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing MultiPolySet3D, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing MultiPolySet3D, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing MultiPolySet3D, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing MultiPolySet3D, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing MultiPolySet3D, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing MultiPolySet3D, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing MultiPolySet3D, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing MultiPolySet3D, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing MultiPolySet3D, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing MultiPolySet3D, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing MultiPolySet3D, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing MultiPolySet3D, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing MultiPolySet3D, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing MultiPolySet3D, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing MultiPolySet3D, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing MultiPolySet3D, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing MultiPolySet3D, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing MultiPolySet3D, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing MultiPolySet3D, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing MultiPolySet3D, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing MultiPolySet3D, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing MultiPolySet3D, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within MultiPolySet3D(A, B): End Testing MULTIPOLYGON against other types';
		
SELECT 'ST_Within MultiPointMSet(A, B): Start Testing MultiPointMSet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing MultiPointMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing MultiPointMSet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing MultiPointMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing MultiPointMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing MultiPointMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing MultiPointMSet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing MultiPointMSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing MultiPointMSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing MultiPointMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing MultiPointMSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing MultiPointMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing MultiPointMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing MultiPointMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing MultiPointMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing MultiPointMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing MultiPointMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing MultiPointMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing MultiPointMSet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing MultiPointMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing MultiPointMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing MultiPointMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing MultiPointMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing MultiPointMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing MultiPointMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing MultiPointMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing MultiPointMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing MultiPointMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing MultiPointMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing MultiPointMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing MultiPointMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within MultiPointMSet(A, B): End Testing MULTIPOINTM against other types';
		
SELECT 'ST_Within MultiLineMSet(A, B): Start Testing MultiLineMSet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing MultiLineMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing MultiLineMSet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing MultiLineMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing MultiLineMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing MultiLineMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing MultiLineMSet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing MultiLineMSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing MultiLineMSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing MultiLineMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing MultiLineMSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing MultiLineMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing MultiLineMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing MultiLineMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing MultiLineMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing MultiLineMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing MultiLineMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing MultiLineMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing MultiLineMSet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing MultiLineMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing MultiLineMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing MultiLineMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing MultiLineMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing MultiLineMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing MultiLineMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing MultiLineMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing MultiLineMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing MultiLineMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing MultiLineMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing MultiLineMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing MultiLineMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within MultiLineMSet(A, B): End Testing MULTILINESTRINGM against other types';
		
SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing MultiPolygonMSet against other types'; 
				
	SELECT 'ST_Within PointSet(A, B): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet(A, B): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolySet(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Within PointMSet(A, B): Start Testing MultiPolygonMSet, POINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointMSet: End Testing MultiPolygonMSet, POINTM';
		
		
		
	SELECT 'ST_Within LineMSet(A, B): Start Testing MultiPolygonMSet, LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineMSet: End Testing MultiPolygonMSet, LINESTRINGM';
		
		
		
	SELECT 'ST_Within PolygonMSet(A, B): Start Testing MultiPolygonMSet, POLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonMSet: End Testing MultiPolygonMSet, POLYGONM';
		
		
		
	SELECT 'ST_Within PointSet3D(A, B): Start Testing MultiPolygonMSet, POINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PointSet3D: End Testing MultiPolygonMSet, POINT';
		
		
		
	SELECT 'ST_Within LineSet3D(A, B): Start Testing MultiPolygonMSet, LINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  LineSet3D: End Testing MultiPolygonMSet, LINESTRING';
		
		
		
	SELECT 'ST_Within PolygonSet3D(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  PolygonSet3D: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Within GCSet3D(A, B): Start Testing MultiPolygonMSet, GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  GCSet3D: End Testing MultiPolygonMSet, GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Within CurvePolySet(A, B): Start Testing MultiPolygonMSet, CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CurvePolySet: End Testing MultiPolygonMSet, CURVEPOLYGON';
		
		
		
	SELECT 'ST_Within CircularStringSet(A, B): Start Testing MultiPolygonMSet, CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  CircularStringSet: End Testing MultiPolygonMSet, CIRCULARSTRING';
		
		
		
	SELECT 'ST_Within MultiPointSet(A, B): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet(A, B): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet(A, B): Start Testing MultiPolygonMSet, POLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet: End Testing MultiPolygonMSet, POLYGON';
		
		
		
	SELECT 'ST_Within MultiPointSet3D(A, B): Start Testing MultiPolygonMSet, MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointSet3D: End Testing MultiPolygonMSet, MULTIPOINT';
		
		
		
	SELECT 'ST_Within MultiLineSet3D(A, B): Start Testing MultiPolygonMSet, MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineSet3D: End Testing MultiPolygonMSet, MULTILINESTRING';
		
		
		
	SELECT 'ST_Within MultiPolySet3D(A, B): Start Testing MultiPolygonMSet, MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolySet3D: End Testing MultiPolygonMSet, MULTIPOLYGON';
		
		
		
	SELECT 'ST_Within MultiPointMSet(A, B): Start Testing MultiPolygonMSet, MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPointMSet: End Testing MultiPolygonMSet, MULTIPOINTM';
		
		
		
	SELECT 'ST_Within MultiLineMSet(A, B): Start Testing MultiPolygonMSet, MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiLineMSet: End Testing MultiPolygonMSet, MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Within MultiPolygonMSet(A, B): Start Testing MultiPolygonMSet, MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Within(foo1.the_geom, foo2.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1 CROSS JOIN ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo2
			LIMIT 3;  
	COMMIT;
	SELECT 'ST_Within(A, B)  MultiPolygonMSet: End Testing MultiPolygonMSet, MULTIPOLYGONM';
		
		
		
SELECT 'ST_Within MultiPolygonMSet(A, B): End Testing MULTIPOLYGONM against other types';
		
	SELECT 'ST_X PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_X PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_X LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_X LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_X PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_X PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_X PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_X PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_X LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_X LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_X PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_X PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_X PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_X PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_X LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_X LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_X PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_X PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_X GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_X GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_X CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_X CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_X CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_X CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_X MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_X MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_X MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_X MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_X MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_X MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_X MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_X MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_X MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_X MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_X MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_X MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_X MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_X MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_X MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_X MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_X MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_X(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_X MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_XMax PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_XMax LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_XMax LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_XMax PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_XMax PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_XMax LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_XMax LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_XMax PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_XMax PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_XMax LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_XMax PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_XMax GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_XMax CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_XMax CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_XMax MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_XMax MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_XMax MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_XMax MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_XMax MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_XMax MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_XMax MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_XMax MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_XMax MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_XMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_XMax MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_XMin PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_XMin LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_XMin LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_XMin PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_XMin PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_XMin LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_XMin LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_XMin PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_XMin PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_XMin LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_XMin PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_XMin GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_XMin CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_XMin CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_XMin MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_XMin MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_XMin MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_XMin MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_XMin MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_XMin MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_XMin MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_XMin MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_XMin MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_XMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_XMin MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Y PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Y PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Y LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Y LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Y PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Y PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Y PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Y PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Y LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Y LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Y PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Y PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Y PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Y PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Y LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Y LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Y PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Y PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Y GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Y GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Y CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Y CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Y CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Y CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Y MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Y MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Y MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Y MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Y MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Y MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Y MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Y MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Y MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Y MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Y MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Y MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Y MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Y MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Y MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Y MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Y MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Y(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Y MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_YMax PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_YMax LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_YMax LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_YMax PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_YMax PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_YMax LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_YMax LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_YMax PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_YMax PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_YMax LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_YMax PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_YMax GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_YMax CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_YMax CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_YMax MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_YMax MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_YMax MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_YMax MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_YMax MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_YMax MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_YMax MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_YMax MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_YMax MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_YMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_YMax MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_YMin PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_YMin LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_YMin LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_YMin PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_YMin PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_YMin LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_YMin LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_YMin PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_YMin PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_YMin LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_YMin PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_YMin GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_YMin CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_YMin CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_YMin MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_YMin MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_YMin MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_YMin MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_YMin MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_YMin MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_YMin MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_YMin MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_YMin MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_YMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_YMin MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Z PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Z PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Z LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Z LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Z PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Z PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Z PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Z PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Z LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Z LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Z PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Z PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Z PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Z PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Z LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Z LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Z PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Z PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Z GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Z GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Z CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Z CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Z CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Z CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Z MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Z MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Z MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Z MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Z MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Z MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Z MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Z MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Z MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Z MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Z MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Z MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Z MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Z MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Z MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Z MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Z MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Z(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Z MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_ZMax PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_ZMax LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_ZMax PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_ZMax PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_ZMax LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_ZMax PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_ZMax PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_ZMax LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_ZMax PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_ZMax GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_ZMax CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_ZMax CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_ZMax MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_ZMax MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_ZMax MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_ZMax MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_ZMax MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_ZMax MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_ZMax MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_ZMax MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_ZMax MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_ZMax(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMax MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_ZMin PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_ZMin LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_ZMin PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_ZMin PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_ZMin LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_ZMin PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_ZMin PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_ZMin LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_ZMin PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_ZMin GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_ZMin CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_ZMin CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_ZMin MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_ZMin MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_ZMin MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_ZMin MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_ZMin MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_ZMin MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_ZMin MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_ZMin MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_ZMin MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_ZMin(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_ZMin MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		
	SELECT 'ST_Zmflag PointSet: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag PointSet: End Testing POINT';
		
		
		
	SELECT 'ST_Zmflag LineSet: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag LineSet: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Zmflag PolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag PolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Zmflag PointMSet: Start Testing POINTM'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag PointMSet: End Testing POINTM';
		
		
		
	SELECT 'ST_Zmflag LineMSet: Start Testing LINESTRINGM'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j))) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag LineMSet: End Testing LINESTRINGM';
		
		
		
	SELECT 'ST_Zmflag PolygonMSet: Start Testing POLYGONM'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag PolygonMSet: End Testing POLYGONM';
		
		
		
	SELECT 'ST_Zmflag PointSet3D: Start Testing POINT'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePoint(i,j,k),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag PointSet3D: End Testing POINT';
		
		
		
	SELECT 'ST_Zmflag LineSet3D: Start Testing LINESTRING'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag LineSet3D: End Testing LINESTRING';
		
		
		
	SELECT 'ST_Zmflag PolygonSet3D: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag PolygonSet3D: End Testing POLYGON';
		
		
		
	SELECT 'ST_Zmflag GCSet3D: Start Testing GEOMETRYCOLLECTION'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_Collect(ST_SetSRID(ST_MakePoint(i,j,m),4326),ST_SetSRID(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_MakePoint(i+m,j,m),ST_MakePoint(j+m,i-m,m)),ST_MakePoint(i,j,m)),ST_MakePointM(i+m,j,m))),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			GROUP BY m)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag GCSet3D: End Testing GEOMETRYCOLLECTION';
		
		
		
	SELECT 'ST_Zmflag CurvePolySet: Start Testing CURVEPOLYGON'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag CurvePolySet: End Testing CURVEPOLYGON';
		
		
		
	SELECT 'ST_Zmflag CircularStringSet: Start Testing CIRCULARSTRING'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_LineToCurve(ST_Boundary(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag CircularStringSet: End Testing CIRCULARSTRING';
		
		
		
	SELECT 'ST_Zmflag MultiPointSet: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom 
		FROM (SELECT ST_SetSRID(ST_Point(i,j),4326) As the_geom 
		FROM generate_series(-10,50,15) As i 
			CROSS JOIN generate_series(40,70, 15) j) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag MultiPointSet: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Zmflag MultiLineSet: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_Point(i,j),4326),ST_SetSRID(ST_Point(j,i),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 15) As j
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag MultiLineSet: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Zmflag MultiPolySet: Start Testing POLYGON'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_Buffer(ST_SetSRID(ST_Point(i,j),4326), j)))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(40,70, 20) As j)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag MultiPolySet: End Testing POLYGON';
		
		
		
	SELECT 'ST_Zmflag MultiPointSet3D: Start Testing MULTIPOINT'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(ST_SetSRID(ST_MakePoint(i,j,k),4326)) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,3) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag MultiPointSet3D: End Testing MULTIPOINT';
		
		
		
	SELECT 'ST_Zmflag MultiLineSet3D: Start Testing MULTILINESTRING'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_SetSRID(ST_MakeLine(ST_MakePoint(i,j,k), ST_MakePoint(i+k,j+k,k)),4326))) As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(40,70, 20) j
			CROSS JOIN generate_series(1,2) k
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag MultiLineSet3D: End Testing MULTILINESTRING';
		
		
		
	SELECT 'ST_Zmflag MultiPolySet3D: Start Testing MULTIPOLYGON'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(s.the_geom)) As the_geom
		FROM (SELECT ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag MultiPolySet3D: End Testing MULTIPOLYGON';
		
		
		
	SELECT 'ST_Zmflag MultiPointMSet: Start Testing MULTIPOINTM'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_SetSRID(ST_MakePointM(i,j,m),4326) As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) AS j
			CROSS JOIN generate_series(1,2) As m) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag MultiPointMSet: End Testing MULTIPOINTM';
		
		
		
	SELECT 'ST_Zmflag MultiLineMSet: Start Testing MULTILINESTRINGM'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_Collect(s.the_geom) As the_geom
		FROM (SELECT ST_MakeLine(ST_SetSRID(ST_MakePointM(i,j,m),4326),ST_SetSRID(ST_MakePointM(j,i,m),4326))  As the_geom 
		FROM generate_series(-10,50,10) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			WHERE NOT(i = j)) As s)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag MultiLineMSet: End Testing MULTILINESTRINGM';
		
		
		
	SELECT 'ST_Zmflag MultiPolygonMSet: Start Testing MULTIPOLYGONM'; 
	BEGIN; 
	SELECT ST_Zmflag(foo1.the_geom)
			  
			FROM ((SELECT ST_Multi(ST_Union(ST_MakePolygon(ST_AddPoint(ST_AddPoint(ST_MakeLine(ST_SetSRID(ST_MakePointM(i+m,j,m),4326),ST_SetSRID(ST_MakePointM(j+m,i-m,m),4326)),ST_SetSRID(ST_MakePointM(i,j,m),4326)),ST_SetSRID(ST_MakePointM(i+m,j,m),4326)))))  As the_geom 
		FROM generate_series(-10,50,20) As i 
			CROSS JOIN generate_series(50,70, 20) As j
			CROSS JOIN generate_series(1,2) As m
			)) As foo1;  
	COMMIT;
	SELECT 'ST_Zmflag MultiPolygonMSet: End Testing MULTIPOLYGONM';
		
		
		SELECT  'Starting UnlockRows(auth_token)';BEGIN; 
SELECT  UnlockRows('monkey');
COMMIT;
SELECT  'Ending UnlockRows(auth_token)';
	SELECT  'Starting UpdateGeometrySRID(table_name, column_name, srid)';BEGIN; 
SELECT  UpdateGeometrySRID('test', 'test', 3395);
COMMIT;
SELECT  'Ending UpdateGeometrySRID(table_name, column_name, srid)';
	SELECT  'Starting UpdateGeometrySRID(schema_name, table_name, column_name, srid)';BEGIN; 
SELECT  UpdateGeometrySRID('test', 'test', 'test', 3395);
COMMIT;
SELECT  'Ending UpdateGeometrySRID(schema_name, table_name, column_name, srid)';
	SELECT  'Starting UpdateGeometrySRID(catalog_name, schema_name, table_name, column_name, srid)';BEGIN; 
SELECT  UpdateGeometrySRID('test', 'test', 'test', 'test', 3395);
COMMIT;
SELECT  'Ending UpdateGeometrySRID(catalog_name, schema_name, table_name, column_name, srid)';
	